package fr.unice.javinspector.GUI.main;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.FileFilter;
import fr.unice.javinspector.GUI.util.VerticalFlowLayout;
import java.io.File;
import fr.unice.javinspector.core.loader.*;
import java.io.FileNotFoundException;
import java.io.*;

/**
 * <p>Title: Class ClassFileChooser</p>
 * <p>Description: Graphic front end to load classes from JAR, Classes or URL</p>
 * <p>Copyright: UNSA</p>
 * <p>Company: UNSA</p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public class ClassFileChooser extends JDialog {
  JPanel jPanelTop = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanelFilePath = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField jTextFileName = new JTextField();
  JButton jButton1 = new JButton();
  Border border1;
  TitledBorder titledBorder1;
  BorderLayout borderLayout2 = new BorderLayout();
  Class resultClass = null;
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel jPanelBottom = new JPanel();
  JButton jButtonClose = new JButton();
  JButton jButtonLoad = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel jPanelButtons = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanelMiddle = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  TitledBorder titledBorder2;
  JPanel jPanelRadio = new JPanel();
  JPanel jPanelMiddleBottom = new JPanel();
  FlowLayout flowLayout2 = new FlowLayout();
  JRadioButton jRadioButtonJAR = new JRadioButton();
  JRadioButton jRadioButtonURL = new JRadioButton();
  JRadioButton jRadioButtonName = new JRadioButton();
  JRadioButton jRadioButtonFile = new JRadioButton();
  ButtonGroup buttonGroup = new ButtonGroup();
  JLabel jLabel2 = new JLabel();
  JTextField jTextFieldClassName = new JTextField();
  GridBagLayout gridBagLayout2 = new GridBagLayout();

  /* Xav's code begin*/
  private FileClassLoader fcl = new FileClassLoader("");
  private JARClassLoader jcl = null;
  private URLClassLoader ucl = new URLClassLoader("");
  private JarFilter jarFilter = new JarFilter();
  private ClassFilter classFilter = new ClassFilter();
  TitledBorder titledBorder3;
  /* Xav's code end*/


  /**
   * Constructor which takes tha parent window in parameter
   * @param owner the parent window
   * @throws HeadlessException
   */
  public ClassFileChooser(Frame owner) throws HeadlessException {
    super(owner);
    myInit();
  }

  /**
   * init function
   */
  private void myInit(){
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    jButton1.setEnabled(false);
    jTextFileName.setEnabled(false);
    jTextFileName.setColumns(5);
    jTextFieldClassName.setEnabled(true);
    jTextFieldClassName.setColumns(5);
    this.setFocusTraversalPolicy(new javax.swing.LayoutFocusTraversalPolicy());
    this.pack();
  }


  /**
   * Centers the Dialog <CODE>dialog</CODE> over the componet <CODE>c</CODE>
   * @param dialog the Dialog to center
   * @param c the window over which the Dialog should be centered
   */
  public static void showDialogCenteredOverComponent(Dialog dialog, Component c)
   {
     dialog.pack();
     // get the component position
     Point p = c.getLocationOnScreen();

     Dimension d = c.getSize();
     Dimension d1 = dialog.getSize();

     // calculate the splash screen position
     int x = p.x + (d.width - d1.width) / 2;
     int y = p.y + (d.height - d1.height) / 2;
     dialog.setLocation(x, y);
   }


   /**
    * Method to call in order to get the resulted Class loaded
    * @return the loaded Class
    */
   public Class getSelectedClass(){
    return resultClass;
  }


  /**
   * shows the dialod centered over the owner (this is a modal dialog)
   * this function will not return until the user quits the ClassFileChooser Dialog
   * @param owner the window over which the Dialog should be centered
   */
  public void show(Component owner){
    showDialogCenteredOverComponent(this, owner);
    this.show();
  }

  /**
   * shows the dialog (this is a modal dialog)
   * this function will not return until the user quits the ClassFileChooser Dialog
   */
  public void show(){
    resultClass = null;
    fcl.setFilePrefix("");
    fcl.setClassNameReplacementChar('\0');
    jButtonLoad.setFocusPainted(true);
    super.show();
   }
//  jButton1.setNextFocusableComponent(jRadioButtonName);
//   jTextFileName.setNextFocusableComponent(jButton1);
//   jButtonClose.setNextFocusableComponent(jTextFileName);
//   jButtonLoad.setNextFocusableComponent(jButtonClose);
//   jRadioButtonURL.setNextFocusableComponent(jButtonLoad);
//   jRadioButtonJAR.setNextFocusableComponent(jRadioButtonURL);
//   jRadioButtonFile.setNextFocusableComponent(jRadioButtonJAR);
//   jRadioButtonName.setNextFocusableComponent(jRadioButtonFile);

  private void jbInit() throws Exception {
    titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Enter the path of the file or the name");
    jRadioButtonName.setSelected(true);
   border1 = BorderFactory.createLineBorder(SystemColor.controlText,1);
   titledBorder1 = new TitledBorder(border1," load options :");
   titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"From Type : ");
    jPanelTop.setLayout(borderLayout1);
   jPanelFilePath.setLayout(gridBagLayout1);
   jLabel1.setText("Path");
   jButton1.setToolTipText("Find the file to open");
   jButton1.setVerifyInputWhenFocusTarget(true);
   jButton1.setActionCommand("Find");
   jButton1.setSelected(false);
   jButton1.setText("Find...");
   jButton1.addActionListener(new ClassFileChooser_jButton1_actionAdapter(this));
   this.getContentPane().setLayout(borderLayout2);
   borderLayout1.setHgap(0);
   borderLayout1.setVgap(5);
   jPanelFilePath.setAlignmentX((float) 0.5);
   jTextFileName.setToolTipText("");
   jTextFileName.setText("");
   jTextFileName.addKeyListener(new ClassFileChooser_jTextFileName_keyAdapter(this));
   jTextFieldClassName.addKeyListener(new ClassFileChooser_jTextFileName_keyAdapter(this));
   this.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
   this.setModal(true);
   this.setResizable(false);
   this.setTitle("Load a Class File");
    jPanelTop.setBorder(null);
    jPanelTop.setDebugGraphicsOptions(0);
    jPanelTop.setMinimumSize(new Dimension(444, 120));
   jButtonClose.setText("Cancel");
    jButtonClose.addActionListener(new ClassFileChooser_jButtonClose_actionAdapter(this));
    jButtonLoad.setText("Load");
    jButtonLoad.addActionListener(new ClassFileChooser_jButtonLoad_actionAdapter(this));
    flowLayout1.setHgap(60);
    flowLayout1.setVgap(5);
    jPanelButtons.setLayout(flowLayout1);
    jPanelBottom.setLayout(borderLayout3);
    jPanelMiddle.setLayout(borderLayout4);
    jPanelRadio.setBorder(titledBorder2);
    jPanelRadio.setMinimumSize(new Dimension(280, 60));
    jPanelRadio.setPreferredSize(new Dimension(300, 60));
    jPanelRadio.setToolTipText("");
    jPanelRadio.setLayout(flowLayout2);
    jRadioButtonJAR.setText("JAR");
    jRadioButtonJAR.addActionListener(new ClassFileChooser_jRadioButton_actionAdapter(this));
    jRadioButtonURL.setText("URL");
    jRadioButtonURL.addActionListener(new ClassFileChooser_jRadioButton_actionAdapter(this));
    jRadioButtonName.setText("Name");
    jRadioButtonName.addActionListener(new ClassFileChooser_jRadioButton_actionAdapter(this));
    jRadioButtonFile.setText("File");
    jRadioButtonFile.addActionListener(new ClassFileChooser_jRadioButton_actionAdapter(this));
    flowLayout2.setHgap(30);
    jLabel2.setText("Name");
    jPanelMiddleBottom.setLayout(gridBagLayout2);
    jTextFieldClassName.setText("");
    jPanelMiddle.setBorder(titledBorder3);
    jPanelRadio.add(jRadioButtonName, null);
    jPanelRadio.add(jRadioButtonFile, null);
    jPanelRadio.add(jRadioButtonJAR, null);
    jPanelRadio.add(jRadioButtonURL, null);
    this.getContentPane().add(jPanelTop, BorderLayout.CENTER);
   jPanelTop.add(jPanelRadio,  BorderLayout.NORTH);
//   jPanelTop.add(jPanelFilePath,  BorderLayout.CENTER);
    jPanelTop.add(jPanelBottom,  BorderLayout.SOUTH);
   jPanelFilePath.add(jTextFileName,  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
           ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(8, 30, 0, 0), 271, 0));
   jPanelFilePath.add(jButton1,  new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
           ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(8, 19, 0, 49), 0, -3));
   jPanelFilePath.add(jLabel1,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
           ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 28, 0, 0), 11, 0));
    jPanelButtons.add(jButtonLoad, null);
    jPanelButtons.add(jButtonClose, null);
    jPanelBottom.add(jPanelMiddle, BorderLayout.CENTER);
    jPanelBottom.add(jPanelButtons,  BorderLayout.SOUTH);
    jPanelMiddle.add(jPanelFilePath,  BorderLayout.SOUTH);
    jPanelMiddle.add(jPanelMiddleBottom,  BorderLayout.NORTH);
    buttonGroup.add(jRadioButtonName);
    buttonGroup.add(jRadioButtonFile);
    buttonGroup.add(jRadioButtonJAR);
    buttonGroup.add(jRadioButtonURL);
    jPanelMiddleBottom.add(jLabel2,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 30, 0, 0), 18, 6));
    jPanelMiddleBottom.add(jTextFieldClassName,  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(1, 14, 0, 130), 268, 0));
 }

  protected void jButton1_actionPerformed(ActionEvent e) {
    JFileChooser chooser = new JFileChooser();
    // Note: source for ExampleFileFilter can be found in FileChooserDemo,
    // under the demo/jfc directory in the Java 2 MVC, Standard Edition.
    if (jRadioButtonFile.isSelected()) {
      chooser.setFileFilter(classFilter);
    }
    else if (jRadioButtonJAR.isSelected()){
      chooser.setFileFilter(jarFilter);
    }
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      jTextFileName.setText(chooser.getSelectedFile().getAbsolutePath());
    }
  }

  protected void jButtonLoad_actionPerformed(ActionEvent e) {
    GeneralClassLoader gcl = null;
    String clazz = null;
    if (jRadioButtonFile.isSelected()){
      gcl = fcl;
      clazz = jTextFileName.getText();
      gcl.setClassNameReplacementChar(File.separatorChar);
    }
    else if (jRadioButtonName.isSelected()){
      gcl = fcl;
      clazz = jTextFieldClassName.getText();
    }
    else if (jRadioButtonJAR.isSelected()){
      try {
        gcl = new JARClassLoader(jTextFileName.getText().trim());
      }
      catch (IOException ex) {
        JOptionPane.showMessageDialog(this,
                                      ex.getMessage(),
                                      ex.getClass().getName(),
                                      JOptionPane.ERROR_MESSAGE);
        return ;
    }
      gcl.setClassNameReplacementChar('/');
      clazz = jTextFieldClassName.getText();
    }
    else if (jRadioButtonURL.isSelected()){
      gcl = ucl;
      clazz = jTextFileName.getText();
    }

    try {
      clazz = clazz.trim();
      if (clazz.endsWith(".class")) clazz = clazz.substring(0, clazz.length() - 6);
      resultClass = gcl.loadClass(clazz);
    }
//    catch (Exception ex){
//      JOptionPane.showMessageDialog(this,
//                                    ex.getMessage(),
//                                    ex.getClass().getName(),
//                                    JOptionPane.ERROR_MESSAGE);
//      return ;
//    }
    catch (ClassNotFoundException ee){
      JOptionPane.showMessageDialog(this,
                                    "The specified class could not be found",
                                    ee.getClass().getName(),
                                    JOptionPane.ERROR_MESSAGE);
      return ;
    }
    catch (NoClassDefFoundError ne){
      JOptionPane.showMessageDialog(this,
                                    "The specified class could not be loaded",
                                    ne.getClass().getName(),
                                    JOptionPane.ERROR_MESSAGE);
      return ;
    }
    catch (LinkageError le) {
      JOptionPane.showMessageDialog(this,
                                    "The specified class could not be loaded"
                                    + "or is already loaded",
                                    le.getClass().getName(),
                                    JOptionPane.ERROR_MESSAGE);
      return ;
    }
    catch (Throwable t){
      JOptionPane.showMessageDialog(this,
                                    "Error : "+ t.getMessage(),
                                    t.getClass().getName(),
                                    JOptionPane.ERROR_MESSAGE);
      return ;
    }


    this.hide();
  }

  protected void jButtonClose_actionPerformed(ActionEvent e) {
    this.hide();
  }


  protected void jRadioButton_actionPerformed(ActionEvent e) {
    if (e.getSource() == jRadioButtonFile){
      jButton1.setEnabled(true);
      jTextFileName.setEnabled(true);
      jTextFieldClassName.setEnabled(false);
    }
    else if (e.getSource() == jRadioButtonJAR) {
      jButton1.setEnabled(true);
      jTextFileName.setEnabled(true);
      jTextFieldClassName.setEnabled(true);
    }
    else if (e.getSource() == jRadioButtonURL) {
      jButton1.setEnabled(false);
      jTextFileName.setEnabled(true);
      jTextFieldClassName.setEnabled(false);
    }
    else if (e.getSource() == jRadioButtonName) {
      jButton1.setEnabled(false);
      jTextFileName.setEnabled(false);
      jTextFieldClassName.setEnabled(true);
    }
  }

  protected void jTextFileName_keyTyped(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER) this.jButtonLoad_actionPerformed(null);
  }




}

class ClassFileChooser_jButton1_actionAdapter implements java.awt.event.ActionListener {
  ClassFileChooser adaptee;

  ClassFileChooser_jButton1_actionAdapter(ClassFileChooser adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class ClassFileChooser_jButtonClose_actionAdapter implements java.awt.event.ActionListener {
  ClassFileChooser adaptee;

  ClassFileChooser_jButtonClose_actionAdapter(ClassFileChooser adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonClose_actionPerformed(e);
  }
}

class ClassFileChooser_jButtonLoad_actionAdapter implements java.awt.event.ActionListener {
  ClassFileChooser adaptee;

  ClassFileChooser_jButtonLoad_actionAdapter(ClassFileChooser adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonLoad_actionPerformed(e);
  }
}

class ClassFileChooser_jRadioButton_actionAdapter implements java.awt.event.ActionListener {
  ClassFileChooser adaptee;

  ClassFileChooser_jRadioButton_actionAdapter(ClassFileChooser adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jRadioButton_actionPerformed(e);
  }
}

class ClassFileChooser_jTextFileName_keyAdapter extends java.awt.event.KeyAdapter {
  ClassFileChooser adaptee;

  ClassFileChooser_jTextFileName_keyAdapter(ClassFileChooser adaptee) {
    this.adaptee = adaptee;
  }
  public void keyPressed(KeyEvent e) {
    adaptee.jTextFileName_keyTyped(e);
  }
}

class JarFilter extends javax.swing.filechooser.FileFilter {

  public boolean accept(File f) {
    return f.isDirectory()
        || f.getName().endsWith(".jar")
        || f.getName().endsWith(".JAR");
  }

  //The description of this filter
  public String getDescription() {
    return "JAR files";
  }
}

class ClassFilter extends javax.swing.filechooser.FileFilter {

  public boolean accept(File f) {
    return f.isDirectory()
        || f.getName().endsWith(".class")
        || f.getName().endsWith(".CLASS");
  }

  //The description of this filter
  public String getDescription() {
    return "Java Class files";
  }
}
