package fr.unice.javinspector.GUI.search;

import java.util.ArrayList;
import java.util.Iterator;
import javax.swing.*;
import fr.unice.javinspector.GUI.util.*;
import java.awt.event.*;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Insets;
import java.lang.reflect.Member;
import java.awt.Component;
import fr.unice.javinspector.core.engineSearch.*;

/**
 * <p>Title: EngineSearchFrontEnd </p>
 * <p>Description: this is the front end of the search</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNICE</p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */

public class EngineSearchFrontEnd extends JPanel{

  // for the action listener
  private static Criterion criterion;
  private static JComboBox comboBox;

  private EngineSearch engineSearchRef;

  // for the hight part of the graphics
  private JPanel criterionPanel;
  private JToolBar jBasicsSearch = new JToolBar();
  private JPanel jPanel1 = new JPanel();
  private JButton ValidateQuery = new JButton();
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private JLabel nameofSearch = new JLabel();

  /**
   * Make a new empty FrontEnd search
   */
  private EngineSearchFrontEnd() {
    super();
    criterionPanel = new JPanel();

    nameofSearch.setFont(new java.awt.Font("Serif", 1, 11));
    nameofSearch.setText("Lunch the search");


    ValidateQuery.setFont(new java.awt.Font("Serif", 1, 12));
    ValidateQuery.setBorder(BorderFactory.createRaisedBevelBorder());
    ValidateQuery.setMargin(new Insets(1, 8, 1, 8));
    ValidateQuery.setText("Search !");
    ValidateQuery.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ValidateQuery_actionPerformed(e);
      }
    });


    verticalFlowLayout1.setHgap(10);
    jPanel1.setLayout(verticalFlowLayout1);
    jPanel1.add(nameofSearch, null);

    jBasicsSearch.setBorder(null);
    jBasicsSearch.setMargin(new Insets(1, 3, 1, 3));
    jBasicsSearch.add(jPanel1, null);
    jBasicsSearch.add(ValidateQuery, null);
    this.add(jBasicsSearch, null);
  }

  /**
   * Make a new front end from an Engine Search
   * @param es the engine search for building the Front end.
   */
  public EngineSearchFrontEnd(EngineSearch es){
    this();
    engineSearchRef = es;

    criterionPanel = new JPanel();
    VerticalFlowLayout vfl = new VerticalFlowLayout();
    criterionPanel.setLayout(vfl);
    vfl.setHgap(0);

    ArrayList groupList = es.getGroupSearch();

    JToolBar groupBar = new JToolBar();
    groupBar.setFloatable(false);

    Iterator iter = groupList.iterator();
    int largeurCourante = 0;

    while (iter.hasNext()) {
      GroupCriterion item = (GroupCriterion)iter.next();

      // check for a overflow of the Panel
      JPanel tmpPanel = buildGroupPanel(item);
      if(largeurCourante  > 1 ){
        criterionPanel.add(groupBar);
        groupBar = new JToolBar();
        groupBar.setFloatable(false);
        largeurCourante = 0;
      }

      largeurCourante += 1;
      groupBar.add(tmpPanel);

    }
    criterionPanel.add(groupBar);
    this.add(criterionPanel);
  }

  // private procedure to automaticaly build a Search front end

  /**
   * Construct a new group of criterion panel
   * @param gc the group to construct with
   * @return the penal of gc constructed
   */
  private JPanel buildGroupPanel(GroupCriterion gc){
    JPanel res = new JPanel();
    VerticalFlowLayout vfl = new VerticalFlowLayout();

    vfl.setHgap(10);

    res.setLayout(vfl);

    // add the title of the group
    JLabel title = new JLabel();
    title.setText(gc.getName());
    res.add(title);

    JLabel yes = new JLabel();
    yes.setText("yes");
    JLabel not = new JLabel();
    yes.setText("not");
    JLabel dontmind = new JLabel();
    yes.setText("don't mind");


    // for each criterion add label event ...
    ArrayList criterionList = gc.getCriterion();

    Iterator iter = criterionList.iterator();
    while (iter.hasNext()) {
      Criterion item = (Criterion)iter.next();
      try{
        res.add(buildCriterion(item));
      }catch(SearchEngineException see){
        JOptionPane.showMessageDialog(null,
                                      see.getMessage()+": ignoring this criterion :"+
                                      item.getName(),
                                      "Error ",
                                      JOptionPane.ERROR_MESSAGE);
        System.err.println("Error of programming !!!");
      }

      // check for additionnal component for a criterion.
      ArrayList additionnalComponent = item.isAdditionnalGraphicsComponent();
      if( !additionnalComponent.isEmpty() ){
        Iterator iterAddComp = additionnalComponent.iterator();
        while (iterAddComp.hasNext()) {
          Component item2 = (Component)iterAddComp.next();
          res.add(item2);
        }
      }

    }

    return res;
  }

  /**
   *
   * @param c a criterion to add
   * @return the Graphics component that represent the criterion
   * @throws SearchEngineException
   */
  private JToolBar buildCriterion(Criterion c)
      throws SearchEngineException{

    criterion = c;

    JToolBar result = new JToolBar();

    result.setFloatable(false);

    // init the graphical component

    // the graphical list to choose if AND or OR
//    JComboBox listAndOr = new JComboBox();
//    listAndOr.setEditable(false);
//    listAndOr.setPreferredSize(new Dimension(60,17));
//    listAndOr.setMaximumSize(new Dimension(60,17));
//
//    listAndOr.addItem(new String("AND"));
//    listAndOr.addItem(new String("OR"));
//    comboBox = listAndOr;

//    listAndOr.addActionListener(new java.awt.event.ActionListener() {
//      private JComboBox comboBoxRef = comboBox;
//      private Criterion criterionRef = criterion;
//
//      public void actionPerformed(ActionEvent e) {
//
//        try{
//          if(((String)comboBoxRef.getSelectedItem()).compareTo("AND") == 0){
//            criterionRef.setLogicalLink(EngineSearchConst.AND);
//            System.out.println(criterionRef.getName()+" : AND");
//          }
//          else if(((String)comboBoxRef.getSelectedItem()).compareTo("OR") == 0){
//            criterionRef.setLogicalLink(EngineSearchConst.OR);
//            System.out.println(criterionRef.getName()+" : OR");
//          }
//
//        }catch(SearchEngineException see){
//          JOptionPane.showMessageDialog(null,
//                                        see.getMessage(),
//                                        "Prg Error",
//                                        JOptionPane.ERROR_MESSAGE);
//          System.err.println("Error of programming !!!");
//          System.err.println(see);
//          see.printStackTrace();
//        }
//
//      }
//    });
//
//
//    result.add(listAndOr);

    // the button for making a choice
    ButtonGroup bGroupTypeSearch = new ButtonGroup();

    JRadioButton jRadioYES = new JRadioButton();
    bGroupTypeSearch.add(jRadioYES);
    result.add(jRadioYES);
    jRadioYES.addActionListener(new java.awt.event.ActionListener() {
      private Criterion criterionRef = criterion;

          public void actionPerformed(ActionEvent e) {
            try{
              criterionRef.setUseCriterion(EngineSearchConst.YES);
              System.out.println(criterionRef.getName()+" : YES");

            }catch(SearchEngineException see){
              JOptionPane.showMessageDialog(null,
                  see.getMessage(),
                  "Prg Error",
                  JOptionPane.ERROR_MESSAGE);
              System.err.println("Error of programming !!!");
              System.err.println(see);
              see.printStackTrace();
            }

          }
    });

    JRadioButton jRadioNOT = new JRadioButton();
    bGroupTypeSearch.add(jRadioNOT);
    result.add(jRadioNOT);
    jRadioNOT.addActionListener(new java.awt.event.ActionListener() {
      private Criterion criterionRef = criterion;

          public void actionPerformed(ActionEvent e) {
            try{
              criterionRef.setUseCriterion(EngineSearchConst.NOT);
              System.out.println(criterionRef.getName()+" : NOT");

            }catch(SearchEngineException see){
              JOptionPane.showMessageDialog(null,
                  see.getMessage(),
                  "Prg Error",
                  JOptionPane.ERROR_MESSAGE);
              System.err.println("Error of programming !!!");
              System.err.println(see);
              see.printStackTrace();
            }

          }
    });


    JRadioButton jRadioDONTMIND = new JRadioButton();
    bGroupTypeSearch.add(jRadioDONTMIND);
    result.add(jRadioDONTMIND);

    jRadioDONTMIND.addActionListener(new java.awt.event.ActionListener() {
      private Criterion criterionRef = criterion;

      public void actionPerformed(ActionEvent e) {
        try{
          criterionRef.setUseCriterion(EngineSearchConst.DONTMIND);
          System.out.println(criterionRef.getName()+" : DONTMIND");

        }catch(SearchEngineException see){
          JOptionPane.showMessageDialog(null,
                                        see.getMessage(),
                                        "Prg Error",
                                        JOptionPane.ERROR_MESSAGE);
          System.err.println("Error of programming !!!");
          System.err.println(see);
          see.printStackTrace();
        }

      }
    });

    // check the value by default of the button
    if(c.isActive == EngineSearchConst.DONTMIND)
      jRadioDONTMIND.setSelected(true);
    else if(c.isActive == EngineSearchConst.YES)
      jRadioYES.setSelected(true);
    else if(c.isActive == EngineSearchConst.NOT)
      jRadioNOT.setSelected(true);
    else{
      throw new SearchEngineException(" buildCriterion : Error during the building of the GUI : "+
                                      " a criterion not well initialised");
    }


    // add the title of the criterion
    JLabel criterionTitle = new JLabel();
    criterionTitle.setText(c.getName());
    result.add(criterionTitle);

    return result;
  }

  /**
   * action performed when the search button is cliqued and so
   * a new query submitted.
   * @param e the Action event
   * @throws SearchException
   */
  private void ValidateQuery_actionPerformed(ActionEvent e){

    ArrayList resultSearch  = null;

    // make a new result for a new search
    try{
      resultSearch  = engineSearchRef.search();
    }catch(SearchEngineException see){
      System.err.println(see);
      see.printStackTrace();
      JOptionPane.showMessageDialog(null,
                                    see.getMessage(),
                                    "Error",
                                    JOptionPane.ERROR_MESSAGE);
      return;
    }

    // print the result of the search
    Iterator iter = resultSearch.iterator();
    while (iter.hasNext()) {
      Member item = (Member)iter.next();
      System.out.println(item);
    }


  }


}
