package fr.unice.javinspector.GUI.search;

import javax.swing.border.*;
import javax.swing.*;
import java.awt.*;
import fr.unice.javinspector.core.search.*;
import fr.unice.javinspector.GUI.util.*;
import java.awt.event.*;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import java.util.ArrayList;


/**
 * <p>Title: SearchFrontEnd</p>
 * <p>Description: This class provides a front to use for making search.
 * You can get a panel that allow you to make a search with some parameters.
 * You can get the result in an ArrayList or in a panel.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNICE</p>
 * @author Zerbib Gabriel, Charbit Lucas, Galbois Xavier Gahide Jrme
 * @version 0.1
 */

public class SearchFrontEnd extends JPanel{

  // definition of the constant of this class
  private static final int UNDEFINED = 0;
  private static final int IDONTMIND = 1;
  private static final int VARIABLE  = 2;
  private static final int METHOD    = 3;
  private static final int PUBLIC    = 4;
  private static final int PRIVATE   = 5;
  private static final int PROTECTED = 6;
  private static final int ABSTRACT  = 7;
  private static final int INTERFACE = 8;


  private FrontEndResultSearch frontEndResultSearch;
  private int actionTypeSearch = IDONTMIND;
  private int actionProtection = IDONTMIND;
  private int actionAttribute  = IDONTMIND;
  private int actionClassAttr  = IDONTMIND;

  private BasicsSearch basicSearch = new BasicsSearch();
  private ClassifierAnalyser analyseur;


  private JPanel notUsable = new JPanel();
  private JLabel lj_NotUsable = new JLabel("NOT USABLE");

  private JToolBar jBasicsSearch = new JToolBar();
  private JLabel Titre = new JLabel();
  private JPanel jPanel1 = new JPanel();
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private JButton ValidateQuery = new JButton();
  private JLabel nameofSearch = new JLabel();
  private JToolBar AdvSearch = new JToolBar();
  private VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();
  private JRadioButton nameofSearch2 = new JRadioButton();
  private JPanel attrValue = new JPanel();
  private VerticalFlowLayout verticalFlowLayoutAttr = new VerticalFlowLayout();
  private JRadioButton privateBox = new JRadioButton();
  private JRadioButton ProtectedpBox = new JRadioButton();
  private JRadioButton publicBox = new JRadioButton();
  private JLabel jLprotection = new JLabel();
  private JPanel checkAll = new JPanel();
  private JButton all = new JButton();
  private JButton none = new JButton();
  private GridLayout gridLayout1 = new GridLayout();
  private VerticalFlowLayout verticalFlowLayoutAttr1 = new VerticalFlowLayout();
  private JCheckBox staticBox1 = new JCheckBox();
  private JRadioButton boxAttrdontmind = new JRadioButton();
  private JCheckBox finalBox1 = new JCheckBox();
  private JPanel staticValue = new JPanel();
  private GridLayout gridLayout2 = new GridLayout();
  private JButton none1 = new JButton();
  private JButton all1 = new JButton();
  private JPanel checkAll1 = new JPanel();
  private JLabel jLstatic = new JLabel();
  private JRadioButton boxProtectiondontmind = new JRadioButton();
  private Component component1;
  private Component component4;
  private Component component5;
  private JButton none2 = new JButton();
  private Component component6;
  private Component component7;
  private JRadioButton boxClassAttrdontmind = new JRadioButton();
  private Component component8;
  private JButton all2 = new JButton();
  private JLabel jLclassAttr = new JLabel();
  private GridLayout gridLayout3 = new GridLayout();
  private JPanel classAttr = new JPanel();
  private VerticalFlowLayout verticalFlowLayoutAttr2 = new VerticalFlowLayout();
  private JPanel checkAll2 = new JPanel();
  private JPanel titleSection = new JPanel();
  private JLabel TitleAdvSearch = new JLabel();
  private VerticalFlowLayout verticalFlowLayout3 = new VerticalFlowLayout();
  private JLabel TitleAdvSearch1 = new JLabel();
  private JButton none3 = new JButton();
  private Component component9;
  private JRadioButton boxTypeSearchdontmind = new JRadioButton();
  private Component component10;
  private Component component2;
  private JCheckBox rbMethodSearch = new JCheckBox();
  private JButton all3 = new JButton();
  private JCheckBox rbVariableSearch = new JCheckBox();
  private JLabel jLVarMetFilter = new JLabel();
  private GridLayout gridLayout4 = new GridLayout();
  private JPanel metVarFilter = new JPanel();
  private VerticalFlowLayout verticalFlowLayoutAttr3 = new VerticalFlowLayout();
  private JPanel checkAll3 = new JPanel();
  private ButtonGroup bGroupTypeSearch = new ButtonGroup();
  private ButtonGroup bGroupProtections = new ButtonGroup();
  private JRadioButton jRadioInterface = new JRadioButton();
  private JRadioButton jRadioAbstract = new JRadioButton();
  private ButtonGroup bGroupClassAttr = new ButtonGroup();
  private JComboBox searchText = new JComboBox();
  private TitledBorder titledBorder1;


  public SearchFrontEnd(ClassifierAnalyser analyseur){
    super();
    // init the result search with a no search panel
    // see the FrontEndResultSearch.
    frontEndResultSearch = new FrontEndResultSearch();

    this.analyseur = analyseur;
    this.setName("Search");
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

  }
  private void jbInit() throws Exception {
    component1 = Box.createVerticalStrut(8);
    component4 = Box.createVerticalStrut(8);
    component5 = Box.createVerticalStrut(8);
    component6 = Box.createVerticalStrut(8);
    component7 = Box.createVerticalStrut(8);
    component8 = Box.createVerticalStrut(8);
    component9 = Box.createVerticalStrut(8);
    component10 = Box.createVerticalStrut(8);
    component2 = Box.createVerticalStrut(8);
    titledBorder1 = new TitledBorder("");
    jBasicsSearch.setBorder(null);
    jBasicsSearch.setMargin(new Insets(1, 3, 1, 3));
    Titre.setBackground(Color.lightGray);
    Titre.setFont(new java.awt.Font("Dialog", 1, 12));
    Titre.setText("Search :");
    this.setBackground(Color.gray);
    this.setBorder(BorderFactory.createEtchedBorder());
    this.setPreferredSize(new Dimension(200, 270));
    this.setLayout(verticalFlowLayout2);
    jPanel1.setLayout(verticalFlowLayout1);
    ValidateQuery.setFont(new java.awt.Font("Serif", 1, 12));
    ValidateQuery.setBorder(BorderFactory.createRaisedBevelBorder());
    ValidateQuery.setMargin(new Insets(1, 8, 1, 8));
    ValidateQuery.setText("Search !");
    ValidateQuery.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          ValidateQuery_actionPerformed(e);
        }catch(SearchException se){
          JOptionPane.showMessageDialog(null,
                                        se.getMessage(),
                                        "Reference Error",
                                        JOptionPane.ERROR_MESSAGE);
        }

      }
    });
    nameofSearch.setFont(new java.awt.Font("Serif", 1, 11));
    nameofSearch.setText("name of the method, var to search");
    verticalFlowLayout2.setVgap(0);
    verticalFlowLayout1.setHgap(10);
    nameofSearch2.setFont(new java.awt.Font("Serif", 1, 10));
    nameofSearch2.setSelected(true);
    nameofSearch2.setText("name");
    attrValue.setLayout(verticalFlowLayoutAttr);
    privateBox.setText("private");
    privateBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        privateBox_actionPerformed(e);
      }
    });
    ProtectedpBox.setText("protected");
    ProtectedpBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ProtectedpBox_actionPerformed(e);
      }
    });
    publicBox.setText("public");
    publicBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        publicBox_actionPerformed(e);
      }
    });
    jLprotection.setFont(new java.awt.Font("Serif", 1, 11));
    jLprotection.setText("protections");
    checkAll.setLayout(gridLayout1);
    all.setMinimumSize(new Dimension(0, 0));
    all.setPreferredSize(new Dimension(20, 20));
    all.setHorizontalTextPosition(SwingConstants.CENTER);
    all.setMargin(new Insets(0, 2, 0, 2));
    all.setText("All");
    all.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        all_actionPerformed(e);
      }
    });
    none.setMinimumSize(new Dimension(30, 23));
    none.setHorizontalTextPosition(SwingConstants.CENTER);
    none.setMargin(new Insets(0, 4, 0, 4));
    none.setText("none");
    none.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        none_actionPerformed(e);
      }
    });
    attrValue.setMaximumSize(new Dimension(150, 150));
    attrValue.setMinimumSize(new Dimension(50, 60));
    attrValue.setPreferredSize(new Dimension(110, 140));
    checkAll.setMaximumSize(new Dimension(110, 23));
    checkAll.setMinimumSize(new Dimension(0, 0));
    checkAll.setPreferredSize(new Dimension(85, 20));
    verticalFlowLayoutAttr.setAlignment(VerticalFlowLayout.MIDDLE);
    verticalFlowLayoutAttr.setVgap(0);
    verticalFlowLayoutAttr1.setVgap(0);
    verticalFlowLayoutAttr1.setAlignment(VerticalFlowLayout.MIDDLE);
    staticBox1.setActionCommand("static");
    staticBox1.setText("static");
    boxAttrdontmind.setSelected(true);
    boxAttrdontmind.setText("I dont\'t mind");
    finalBox1.setText("final");
    staticValue.setPreferredSize(new Dimension(110, 120));
    staticValue.setMinimumSize(new Dimension(50, 60));
    staticValue.setMaximumSize(new Dimension(110, 150));
    staticValue.setLayout(verticalFlowLayoutAttr1);
    none1.setMinimumSize(new Dimension(30, 23));
    none1.setHorizontalTextPosition(SwingConstants.CENTER);
    none1.setMargin(new Insets(0, 4, 0, 4));
    none1.setText("none");
    all1.setMinimumSize(new Dimension(0, 0));
    all1.setPreferredSize(new Dimension(20, 20));
    all1.setHorizontalTextPosition(SwingConstants.CENTER);
    all1.setMargin(new Insets(0, 2, 0, 2));
    all1.setText("All");
    checkAll1.setLayout(gridLayout2);
    checkAll1.setMaximumSize(new Dimension(80, 23));
    checkAll1.setMinimumSize(new Dimension(0, 0));
    checkAll1.setPreferredSize(new Dimension(85, 20));
    jLstatic.setFont(new java.awt.Font("Serif", 1, 11));
    jLstatic.setText("attribute");
    boxProtectiondontmind.setSelected(true);
    boxProtectiondontmind.setText("I don\'t mind");
    boxProtectiondontmind.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boxProtectiondontmind_actionPerformed(e);
      }
    });
    none2.setText("none");
    none2.setMargin(new Insets(0, 4, 0, 4));
    none2.setHorizontalTextPosition(SwingConstants.CENTER);
    none2.setMinimumSize(new Dimension(30, 23));
    boxClassAttrdontmind.setSelected(true);
    boxClassAttrdontmind.setText("I don\'t mind");
    boxClassAttrdontmind.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boxClassAttrdontmind_actionPerformed(e);
      }
    });
    all2.setText("All");
    all2.setMargin(new Insets(0, 2, 0, 2));
    all2.setHorizontalTextPosition(SwingConstants.CENTER);
    all2.setPreferredSize(new Dimension(20, 20));
    all2.setMinimumSize(new Dimension(0, 0));
    jLclassAttr.setText("class Attr");
    jLclassAttr.setFont(new java.awt.Font("Serif", 1, 11));
    classAttr.setLayout(verticalFlowLayoutAttr2);
    classAttr.setMaximumSize(new Dimension(95, 150));
    classAttr.setMinimumSize(new Dimension(50, 60));
    classAttr.setPreferredSize(new Dimension(110, 120));
    verticalFlowLayoutAttr2.setVgap(0);
    verticalFlowLayoutAttr2.setAlignment(VerticalFlowLayout.MIDDLE);
    checkAll2.setLayout(gridLayout3);
    checkAll2.setMaximumSize(new Dimension(80, 23));
    checkAll2.setMinimumSize(new Dimension(0, 0));
    checkAll2.setPreferredSize(new Dimension(85, 20));
    TitleAdvSearch.setFont(new java.awt.Font("Serif", 1, 12));
    TitleAdvSearch.setHorizontalAlignment(SwingConstants.CENTER);
    TitleAdvSearch.setHorizontalTextPosition(SwingConstants.CENTER);
    TitleAdvSearch.setText("parameters");
    titleSection.setLayout(verticalFlowLayout3);
    TitleAdvSearch1.setText("Advenced");
    TitleAdvSearch1.setVerticalAlignment(SwingConstants.BOTTOM);
    TitleAdvSearch1.setHorizontalAlignment(SwingConstants.CENTER);
    TitleAdvSearch1.setHorizontalTextPosition(SwingConstants.CENTER);
    TitleAdvSearch1.setFont(new java.awt.Font("Serif", 1, 12));
    TitleAdvSearch1.setMinimumSize(new Dimension(49, 50));
    TitleAdvSearch1.setPreferredSize(new Dimension(59, 17));
    verticalFlowLayout3.setAlignment(FlowLayout.CENTER);
    none3.setText("none");
    none3.setMargin(new Insets(0, 4, 0, 4));
    none3.setHorizontalTextPosition(SwingConstants.CENTER);
    none3.setMinimumSize(new Dimension(30, 23));
    boxTypeSearchdontmind.setSelected(true);
    boxTypeSearchdontmind.setText("I dont\'t mind");
    boxTypeSearchdontmind.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boxTypeSearchdontmind_actionPerformed(e);
      }
    });
    rbMethodSearch.setText("Method");
    rbMethodSearch.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        rbMethodSearch_actionPerformed(e);
      }
    });
    all3.setText("All");
    all3.setMargin(new Insets(0, 2, 0, 2));
    all3.setHorizontalTextPosition(SwingConstants.CENTER);
    all3.setPreferredSize(new Dimension(20, 20));
    all3.setMinimumSize(new Dimension(0, 0));
    rbVariableSearch.setText("Variable");
    rbVariableSearch.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        rbVariableSearch_actionPerformed(e);
      }
    });
    rbVariableSearch.setActionCommand("static");
    jLVarMetFilter.setText("type of search");
    jLVarMetFilter.setFont(new java.awt.Font("Serif", 1, 11));
    metVarFilter.setLayout(verticalFlowLayoutAttr3);
    metVarFilter.setMaximumSize(new Dimension(110, 150));
    metVarFilter.setMinimumSize(new Dimension(50, 60));
    metVarFilter.setPreferredSize(new Dimension(110, 120));
    verticalFlowLayoutAttr3.setVgap(0);
    verticalFlowLayoutAttr3.setAlignment(VerticalFlowLayout.MIDDLE);
    checkAll3.setLayout(gridLayout4);
    checkAll3.setMaximumSize(new Dimension(80, 23));
    checkAll3.setMinimumSize(new Dimension(0, 0));
    checkAll3.setPreferredSize(new Dimension(85, 20));
    jRadioInterface.setText("Interface");
    jRadioInterface.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jRadioInterface_actionPerformed(e);
      }
    });
    jRadioAbstract.setText("abstract");
    jRadioAbstract.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jRadioAbstract_actionPerformed(e);
      }
    });
    searchText.setEditable(true);
    classAttr.add(jLclassAttr, null);
    classAttr.add(jRadioInterface, null);
    staticValue.add(jLstatic, null);
    staticValue.add(staticBox1, null);
    staticValue.add(finalBox1, null);
    staticValue.add(boxAttrdontmind, null);
    checkAll1.add(all1, null);
    checkAll1.add(none1, null);

    staticValue.add(component1, null);
    staticValue.add(component4, null);
    staticValue.add(component5, null);
    staticValue.add(checkAll1, null);
    checkAll2.add(all2, null);
    checkAll2.add(none2, null);
    metVarFilter.add(jLVarMetFilter, null);
    metVarFilter.add(rbVariableSearch, null);
    metVarFilter.add(rbMethodSearch, null);
    metVarFilter.add(boxTypeSearchdontmind, null);
    metVarFilter.add(component2, null);
    metVarFilter.add(component10, null);
    metVarFilter.add(component9, null);
    metVarFilter.add(checkAll3, null);
    checkAll3.add(all3, null);
    checkAll3.add(none3, null);
    AdvSearch.add(titleSection, null);
    AdvSearch.add(nameofSearch2, null);
    AdvSearch.add(metVarFilter, null);
    titleSection.add(TitleAdvSearch1, null);
    titleSection.add(TitleAdvSearch, null);
    AdvSearch.add(attrValue, null);
    this.add(jBasicsSearch, null);
    jBasicsSearch.add(Titre, null);
    jBasicsSearch.add(jPanel1, null);
    jPanel1.add(nameofSearch, null);
    jPanel1.add(searchText, null);
    jBasicsSearch.add(ValidateQuery, null);
    this.add(AdvSearch, null);
    checkAll.add(all, null);
    checkAll.add(none, null);
    AdvSearch.add(staticValue, null);
    AdvSearch.add(classAttr, null);
    attrValue.add(jLprotection, null);
    attrValue.add(publicBox, null);
    attrValue.add(ProtectedpBox, null);
    attrValue.add(privateBox, null);
    attrValue.add(boxProtectiondontmind, null);
    attrValue.add(checkAll, null);
    bGroupTypeSearch.add(rbVariableSearch);
    bGroupTypeSearch.add(rbMethodSearch);
    bGroupTypeSearch.add(boxTypeSearchdontmind);
    bGroupProtections.add(publicBox);
    bGroupProtections.add(ProtectedpBox);
    bGroupProtections.add(privateBox);
    bGroupProtections.add(boxProtectiondontmind);
    classAttr.add(jRadioAbstract, null);
    classAttr.add(boxClassAttrdontmind, null);
    classAttr.add(component7, null);
    classAttr.add(component6, null);
    classAttr.add(component8, null);
    classAttr.add(checkAll2, null);
    bGroupClassAttr.add(jRadioInterface);
    bGroupClassAttr.add(jRadioAbstract);
    bGroupClassAttr.add(boxClassAttrdontmind);
    searchText.addItem(new String("Input a pattern to search"));

    notUsable.add(lj_NotUsable);

  }

  void none_actionPerformed(ActionEvent e) {

  }

  void all_actionPerformed(ActionEvent e) {

  }


  // action performed when the search button is cliqued

  /**
   * action performed when the search button is cliqued and so
   * a new query submitted.
   * @param e the Action event
   * @throws SearchException
   */
  private void ValidateQuery_actionPerformed(ActionEvent e)
      throws SearchException{
    ArrayList searchResultArray = null;
    // get back the information about the search to do.
    if(actionTypeSearch == VARIABLE){
      // check for incompatibility search.
      if(actionClassAttr == ABSTRACT)
        throw new SearchException(0);
      if(actionClassAttr == INTERFACE)
        throw new SearchException(1);

      if(nameofSearch2.isSelected()){
        searchResultArray = basicSearch.getVariable(analyseur,
            (String)searchText.getSelectedItem());
      }
      else{
        searchResultArray = basicSearch.getVariable(analyseur,3,3);
      }

    }
    else if(actionTypeSearch == METHOD){
      if(nameofSearch2.isSelected()){
        searchResultArray = basicSearch.getMethod(analyseur,
            (String)searchText.getSelectedItem());
      }
      else{
        searchResultArray = basicSearch.getMethod(analyseur,4,3,3,3);
      }
    }
    else if(actionTypeSearch == IDONTMIND){
      searchResultArray = basicSearch.getVariable(analyseur,
          (String)searchText.getSelectedItem());

      searchResultArray.addAll(basicSearch.getMethod(analyseur,
          (String)searchText.getSelectedItem()));
    }
    else if(actionTypeSearch == UNDEFINED){
      throw new SearchException(SearchException.UNDEFINE_TYPE_SEARCH);
    }

    // make a new result for a new search
    try{
      frontEndResultSearch = new FrontEndResultSearch(searchResultArray,
        (String)searchText.getSelectedItem());
    }catch(SearchException se){
      se.getMessage();
      JOptionPane.showMessageDialog(this,
                                    se.getMessage(),
                                    "Prg Error",
                                    JOptionPane.ERROR_MESSAGE);
    }


    // test for the combo box
    System.out.println((String)searchText.getSelectedItem());
    if(searchText.getSelectedIndex() == -1){
      searchText.addItem(searchText.getSelectedItem());
    }

  }

  /**
   * @return the result of the last search onclosed in a panel. The panel is
   * formatted.
   */
  public FrontEndResultSearch getFers() {
    return frontEndResultSearch;
  }

  // action for the ACTION TYPE SEARCH

  private void rbVariableSearch_actionPerformed(ActionEvent e) {
    actionTypeSearch = VARIABLE;
  }

  private void rbMethodSearch_actionPerformed(ActionEvent e) {
    actionTypeSearch = METHOD;
  }

  private void boxTypeSearchdontmind_actionPerformed(ActionEvent e) {
    actionTypeSearch = IDONTMIND;
  }

  // action for the ACTION PROTECTION

  private void publicBox_actionPerformed(ActionEvent e) {
    actionProtection = PUBLIC;
  }

  private void ProtectedpBox_actionPerformed(ActionEvent e) {
    actionProtection = PROTECTED;
  }

  private void privateBox_actionPerformed(ActionEvent e) {
    actionProtection = PRIVATE;
  }

  private void boxProtectiondontmind_actionPerformed(ActionEvent e) {
    actionProtection = IDONTMIND;
  }

  private void jRadioInterface_actionPerformed(ActionEvent e) {
    actionClassAttr = INTERFACE;
  }

  private void jRadioAbstract_actionPerformed(ActionEvent e) {
    actionClassAttr = ABSTRACT;
  }

  private void boxClassAttrdontmind_actionPerformed(ActionEvent e) {
    actionClassAttr = IDONTMIND;
  }




}
