package fr.unice.javinspector.GUI.search;

import java.awt.*;
import javax.swing.*;
import fr.unice.javinspector.core.search.*;
import fr.unice.javinspector.core.analyser.Inspector;
import fr.unice.javinspector.GUI.search.EngineSearchFrontEnd;
import fr.unice.javinspector.core.engineSearch.EngineSearch;
import fr.unice.javinspector.GUI.search.SimpleSearch;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import javax.swing.border.*;
import fr.unice.javinspector.GUI.JavInspectorGUI;

import java.awt.event.*;
import java.util.ArrayList;
import fr.unice.javinspector.core.engineSearch.SearchEngineException;
import fr.unice.javinspector.GUI.search.ResultSearch;
import java.util.Iterator;
import java.lang.reflect.Member;
import fr.unice.javinspector.GUI.util.VerticalFlowLayout;
import java.awt.FlowLayout;
import fr.unice.javinspector.GUI.search.AdvancedSearch;
import fr.unice.javinspector.core.engineSearch.advancedEngineSearch.AdvancedEngineSearch;
import fr.unice.javinspector.core.engineSearch.*;
import fr.unice.javinspector.GUI.util.JTabbedPaneWithCloseIcons;

/**
 * <p>Title: Search Window</p>
 * <p>Description: this class is an graphic class for representing
 * the engine search and the advanced engine search.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNSA </p>
 * @author Charbit Lucas - Gahide Jrome - Galbois Xavier - Zerbib Gabriel
 * @version 1.0
 */

public class SearchWindow extends JDialog {
  private JavInspectorGUI main;

  private JButton buttonSubmitSimple;

  private Frame parentFrame;

  private SimpleSearch ss;

  private JTabbedPaneWithCloseIcons jtabbedPaneRef;

  private int i = 0;

  private JPanel panel1 = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private TitledBorder titledBorder1;

  private Inspector currentInspector;

  public SearchWindow(Frame frame, String title, boolean modal) {
    super(frame, title, modal);

    parentFrame = frame;

    ((JavInspectorGUI)frame).getPanelSearch().setBackground(Color.white);
    jtabbedPaneRef = ((JavInspectorGUI)frame).getJTabbedPaneSearch();

    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public SearchWindow(Frame owner) {
    this(owner, "", true);
    this.main = (JavInspectorGUI)owner;
  }

//  public void setClassifierAnalyser(ClassifierAnalyser classifierAnalyser) {
//
//      panel1.removeAll();
//      JPanel toto = ((JavInspectorGUI)parentFrame).getPanelSearch();
//
//      ss = new SimpleSearch(classifierAnalyser, toto, this);
//
//      panel1.setLayout(new VerticalFlowLayout());
//      panel1.add(ss);
//
//      // le ref sur les bouttons
//      buildSubmitSimpleSearchButton();
//  }

  public void setInspector(Inspector inspector) {

      panel1.removeAll();
      JPanel toto = ((JavInspectorGUI)parentFrame).getPanelSearch();

      // take a ref of the inspector.
      this.currentInspector = inspector;
      ss = new SimpleSearch(inspector, toto, this);

      panel1.setLayout(new VerticalFlowLayout());
      panel1.add(ss);

      // le ref sur les bouttons
      buildSubmitSimpleSearchButton();
  }

  public void show(Component owner){
    showDialogCenteredOverComponent(this, owner);
    this.setSize(new Dimension(330,230));
    this.setResizable(false);

    // set the windows center
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int largeurEcran = screenSize.width;
    int hauteurEcran = screenSize.height;

    int largeurFrame = getSize().width;
    int hauteurFrame = getSize().height;
    int posX = (largeurEcran-largeurFrame)/2;
    int posY = (hauteurEcran-hauteurFrame)/2 - 150;

    this.setLocation(posX, posY);
    try{
      this.show();
    }catch(Throwable t){

    }
  }

  /**
   * Centers the Dialog <CODE>dialog</CODE> over the componet <CODE>c</CODE>
   * @param dialog the Dialog to center
   * @param c the window over which the Dialog should be centered
   */
  public static void showDialogCenteredOverComponent(Dialog dialog, Component c) {
    dialog.pack();
    // get the component position
    Point p = c.getLocationOnScreen();

    Dimension d = c.getSize();
    Dimension d1 = dialog.getSize();

    // calculate the splash screen position
    int x = p.x + (d.width - d1.width) / 2;
    int y = p.y + (d.height - d1.height) / 2;
    dialog.setLocation(x, y);
  }

  public JavInspectorGUI getmain() {
    return main;
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Search");
    panel1.setLayout(borderLayout1);
    this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    this.setTitle("Search window");
    panel1.setBorder(titledBorder1);
    panel1.setMinimumSize(new Dimension(200, 130));
    panel1.setPreferredSize(new Dimension(200, 130));
    getContentPane().add(panel1);



  }

  /**
   * called when the submit button is cliqued, so when a search is lunched.
   * @param e the action event.
   */
  private void ValidateQuery_actionPerformed(ActionEvent e){

    ArrayList resultSearchList  = null;

    // make a new result for a new search
    try{
      resultSearchList  = ss.getEs().search();
    }catch(SearchEngineException see){
      see.printStackTrace();
      JOptionPane.showMessageDialog(this,
                                    see.getMessage(),
                                    "Error during the search",
                                    JOptionPane.ERROR_MESSAGE);
      return;
    }


    // place trhe result in the Panel.
    JPanel panelTemp = new ResultSearch(resultSearchList);

    jtabbedPaneRef.addTab("search "+i,panelTemp);
    jtabbedPaneRef.setSelectedIndex(jtabbedPaneRef.getTabCount()-1);
    i++;

    // print the result of the search
//    Iterator iter = resultSearchList.iterator();
//    while (iter.hasNext()) {
//      Member item = (Member)iter.next();
//      System.out.println(item);
//    }

    this.setVisible(false);
    main.showResultPanel(true);

  }
  public JTabbedPaneWithCloseIcons getJtabbedPaneRef() {
    return jtabbedPaneRef;
  }
  public JButton getButtonSubmitSimple() {
    return buttonSubmitSimple;
  }

  private void buildSubmitSimpleSearchButton(){
    buttonSubmitSimple = ss.getJButtonSubmitSimpleSearch();
    buttonSubmitSimple.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        // check the valu of the combo
        String classInsp = (String)ss.getChoiceCombo().getSelectedItem();
        if(classInsp.compareTo("All Classifier")==0){
           ss.setInspector(currentInspector);
        }else{
          // set the the classifier to search in.
          ClassifierAnalyser caTmp = currentInspector.getClassifierAnalyser(classInsp);
          ss.setClassifier(caTmp);
        }

        ValidateQuery_actionPerformed(e);
      }
    });
  }
  public SimpleSearch getSs() {
    return ss;
  }
  public Inspector getCurrentInspector() {
    return currentInspector;
  }

}
