package fr.unice.javinspector.GUI.util;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import java.lang.reflect.Modifier;
import java.util.Hashtable;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public class IconBank {
  public static int FIELD = 1<<16;
  public static int METHOD = 1<<17;
  public static int CONSTRUCTOR = 1<<18;
//  public static int INTERFACE = 1<<19;
  public static int CLASSIFIER = 1<<20;
  private static int STATIC = Modifier.STATIC;
  private static int PACKAGE = 0;
  private static int PRIVATE = Modifier.PRIVATE;
  private static int PROTECTED = Modifier.PROTECTED;
  private static int INTERFACE = Modifier.INTERFACE;
  private static int PUBLIC = Modifier.PUBLIC;
  private static int TYPE_MASK = FIELD | METHOD | CONSTRUCTOR | CLASSIFIER;
  private static int MODIFIER_MASK = STATIC | PRIVATE | PROTECTED | PUBLIC | INTERFACE;
  private static Hashtable allIcons = new Hashtable();
  private static String imgRep = "/imgs/";

  static {
    setIcon(FIELD, PRIVATE, imgRep + "variablePrivate.gif");
    setIcon(FIELD, PROTECTED, imgRep + "variableProtected.gif");
    setIcon(FIELD, PACKAGE, imgRep + "variablePackage.gif");
    setIcon(FIELD, PUBLIC, imgRep + "variablePublic.gif");

    setIcon(FIELD, PRIVATE | STATIC, imgRep + "variableStPrivate.gif");
    setIcon(FIELD, PROTECTED | STATIC, imgRep + "variableStProtected.gif");
    setIcon(FIELD, PACKAGE | STATIC, imgRep + "variableStPackage.gif");
    setIcon(FIELD, PUBLIC | STATIC, imgRep + "variableStPublic.gif");

    setIcon(METHOD, PRIVATE, imgRep + "methodPrivate.gif");
    setIcon(METHOD, PROTECTED, imgRep + "methodProtected.gif");
    setIcon(METHOD, PACKAGE, imgRep + "methodPackage.gif");
    setIcon(METHOD, PUBLIC, imgRep + "methodPublic.gif");

    setIcon(METHOD, PRIVATE | STATIC, imgRep + "methodStPrivate.gif");
    setIcon(METHOD, PROTECTED | STATIC, imgRep + "methodStProtected.gif");
    setIcon(METHOD, PACKAGE | STATIC, imgRep + "methodStPackage.gif");
    setIcon(METHOD, PUBLIC | STATIC, imgRep + "methodStPublic.gif");

    setIcon(CONSTRUCTOR, PRIVATE, imgRep + "constructorPrivate.gif");
    setIcon(CONSTRUCTOR, PROTECTED, imgRep + "constructorProtected.gif");
    setIcon(CONSTRUCTOR, PACKAGE, imgRep + "constructorPackage.gif");
    setIcon(CONSTRUCTOR, PUBLIC, imgRep + "constructorPublic.gif");

    setIcon(CLASSIFIER, 0, imgRep + "class.gif");
    setIcon(CLASSIFIER, INTERFACE, imgRep + "interface.gif");
  }

  public static void load(){}

  private static Icon getIcon(int type, int modifier ){
    type = type & TYPE_MASK;
    modifier = modifier & MODIFIER_MASK;
    return (Icon) allIcons.get(new Integer(type | modifier));
  }


  private static void setIcon(int type, int modifier, String rpath){
    type = type & TYPE_MASK;
    modifier = modifier & MODIFIER_MASK;
    Icon res = new ImageIcon(IconBank.class.getResource(rpath));
    allIcons.put(new Integer(type | modifier), res);
  }

  public static Icon getClassIcon(){
    return getIcon(CLASSIFIER, 0);
  }
  public static Icon getInterfaceIcon(){
    return getIcon(CLASSIFIER, INTERFACE);
  }

  public static Icon getClassifierIcon(int modifier){
    return getIcon(CLASSIFIER, modifier & INTERFACE);
  }

  public static Icon getMethodIcon(int modifier){
    return getIcon(METHOD, modifier);
  }

  public static Icon getFieldIcon(int modifier){
    return getIcon(FIELD, modifier);
  }

  public static Icon getConstructorIcon(int modifier){
    return getIcon(CONSTRUCTOR, modifier);
  }

}
