package fr.unice.javinspector.MVC.controler;

import fr.unice.javinspector.MVC.*;
import fr.unice.javinspector.MVC.view.View;
import fr.unice.javinspector.plugin.*;
/**
 * <p>Title: </p>
 * <p>Description: A controler must have the default constructor with no parameter
 * and the constructor : <code>Controler(fr.unice.javinspector.MVC.manager.Manager , fr.unice.javinspector.MVC.view.View)
 * </code>
 *
 * </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public interface Controler extends Plugin{
  /**
   * gets the view associates to this component
   * @return the view associated to this component
   */
  public View getView();
  /**
   * tels this controler to its associated view
   */
  public void listenToView();
  /**
   * tells whether the given view is controlable by this
   * controler
   * @param v the view to test
   * @return true if it is compatible, false otherwise
   */
  public boolean isControlable(View v);
  /**
   * get the default view associates with this controler
   * @return the name of the view;
   */
  public String getDefaultView();
}
