package fr.unice.javinspector.MVC.manager;
import fr.unice.javinspector.MVC.view.*;
import fr.unice.javinspector.MVC.controler.*;
import fr.unice.javinspector.core.analyser.Inspector;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;

/**
 * <p>Title: JavInspector</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public interface Manager extends View, Controler {
  /**
   * get the inspector from the topmanager
   * @return the current inspector
   */
  public Inspector getInspector();
  /**
   * gets the class of the plugin of the requested type
   * @param type the type of the plugin to get
   * @return the <code>Class</code> object of the plugin
   */
  public Class getPlugin(int type);
  /**
   * add a new HertigeView
   * @param ca the data model to represent in hte view
   */
  public void addHeritageView(ClassifierAnalyser ca);
  /**
   * add a new DetailView
   * @param ca the data model to represent in hte view
   */
  public void addDetailView(ClassifierAnalyser ca);
  /**
   * add a new CompositionView
   * @param ca the data model to represent in hte view
   */
  public void addCompositionView(ClassifierAnalyser ca);
  /**
   * add a new SearchView
   * @param ca the data model to represent in hte view
   */
  public void addSearchView(ClassifierAnalyser ca);
  /**
   *
   * @return the topmanager
   */
  public AbstractTopManager getTopManager();
}
