package fr.unice.javinspector.MVC.manager;

import fr.unice.javinspector.plugin.*;
import fr.unice.javinspector.MVC.view.*;
import javax.swing.*;
import java.awt.*;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import fr.unice.javinspector.MVC.controler.CompositionControler;
import fr.unice.javinspector.MVC.controler.AbstractControler;
import fr.unice.javinspector.MVC.controler.DetailControler;
import fr.unice.javinspector.GUI.util.JTabbedPaneWithCloseIcons;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import fr.unice.javinspector.GUI.util.IconBank;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Charbit Lucas - Gahide Jrome - Galbois Xavier - Zerbib Gabriel
 * @version 1.0
 */

public class TabbedPaneDACManager
    extends AbstractManager {
  private int index = 0;
  JPanel globalPanel = new JPanel();
  JPanel centerPanel = new JPanel();
  private ImageIcon detailIcon = new ImageIcon(TabbedPaneDACManager.class.
                                               getResource("/imgs/detailicon.gif"));
  private ImageIcon compositionIcon = new ImageIcon(TabbedPaneDACManager.class.
      getResource("/imgs/compositionicon.gif"));
  private Icon classIcon = IconBank.getClassIcon();
  private Icon interfaceIcon = IconBank.getInterfaceIcon();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanelTop = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel jLabelDescription = new JLabel();
  FlowLayout flowLayout1 = new FlowLayout();
  JTabbedPaneWithCloseIcons jTabbedPaneDACView = new JTabbedPaneWithCloseIcons();
  BorderLayout borderLayout3 = new BorderLayout();

  public String getName() {
    return this.getClass().getName();
  }

  public Container getViewContainer() {
    return globalPanel;
  }

  public TabbedPaneDACManager(Manager topManager) {
    super(topManager);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    globalPanel.registerKeyboardAction(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        int index = jTabbedPaneDACView.getSelectedIndex();
        if (index > -1) {
          jTabbedPaneDACView.setSelectedIndex(index ==
                                              jTabbedPaneDACView.getTabCount() -
                                              1 ? 0 : index + 1);
        }
      }
    }

    , KeyStroke.getKeyStroke(KeyEvent.VK_UP, ActionEvent.CTRL_MASK, true),
        JComponent.WHEN_IN_FOCUSED_WINDOW);

    globalPanel.registerKeyboardAction(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        int index = jTabbedPaneDACView.getSelectedIndex();
        if (index > -1) {
          jTabbedPaneDACView.setSelectedIndex(index == 0 ?
                                              jTabbedPaneDACView.getTabCount() -
                                              1 : index - 1);
        }
      }
    }

    , KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, ActionEvent.CTRL_MASK, true),
        JComponent.WHEN_IN_FOCUSED_WINDOW);

  }

  public void addDetailView(ClassifierAnalyser ca) {
    this.addView(ca);
  }

  public void addCompositionView(ClassifierAnalyser ca) {
    this.addView(ca);
  }

  public void addView(ClassifierAnalyser ca) {
    Container detailRes = this.newDetailView(ca);
    Container compositionRes = this.newCompositionView(ca);
    JTabbedPane tp = new JTabbedPane();
    tp.setTabPlacement(JTabbedPane.BOTTOM);
    JScrollPane js = new JScrollPane(detailRes);
    js.getVerticalScrollBar().setUnitIncrement(40);
    tp.addTab("Detail view", detailIcon, js);
    JScrollPane js2 = new JScrollPane(compositionRes);
    js2.getVerticalScrollBar().setUnitIncrement(40);
    tp.addTab("Composition view", compositionIcon, js2);
    String classifierName = ca.getClassAnalysed().getName();
    String shortClassifiername = ClassifierAnalyser.shortName(classifierName);
    String modifier = ca.modifierToString();
    if (ca.getClassAnalysed().isInterface()) {
      jLabelDescription.setText(
          "Type Ctrl-UP or Ctrl-DOWN to change tabbed pane    ");
      jTabbedPaneDACView.addTab(shortClassifiername, tp, interfaceIcon,
                                modifier + " interface " + classifierName);
      jTabbedPaneDACView.setSelectedIndex(jTabbedPaneDACView.getTabCount() - 1);

    }
    else {
      jLabelDescription.setText(
          "Type Ctrl-UP or Ctrl-DOWN to change tabbed pane    ");
      jTabbedPaneDACView.addTab(shortClassifiername, tp, classIcon,
                                modifier + " Class " + classifierName);
      jTabbedPaneDACView.setSelectedIndex(jTabbedPaneDACView.getTabCount() - 1);
    }
  }

  public Container newCompositionView(ClassifierAnalyser ca) {
    Class CompositionViewClass = this.getPlugin(PluginTypes.COMPOSITION_VIEW);
    Class CompositionControlerClass = this.getPlugin(PluginTypes.
        COMPOSITION_CONTROLER);
    CompositionView cv = null;
    CompositionControler cc = null;
    try {
      cv = (CompositionView) AbstractView.create(CompositionViewClass, ca);
      cc = (CompositionControler) AbstractControler.create(
          CompositionControlerClass, this, cv);
    }
    catch (Exception e) {
      e.printStackTrace();
      JOptionPane.showMessageDialog(this.getViewContainer(),
                                    "Can't create view",
                                    "Composition view creation error message",
                                    JOptionPane.ERROR_MESSAGE);
      return null;
    }
    return cv.getViewContainer();
  }

  public Container newDetailView(ClassifierAnalyser ca) {
    Class detailViewClass = this.getPlugin(PluginTypes.DETAIL_VIEW);
    Class detailControlerClass = this.getPlugin(PluginTypes.DETAIL_CONTROLER);
    DetailView dv = null;
    DetailControler dc = null;
    try {
      dv = (DetailView) AbstractView.create(detailViewClass, ca);
      dc = (DetailControler) AbstractControler.create(detailControlerClass, this,
          dv);
    }
    catch (Exception e) {
      e.printStackTrace();
      JOptionPane.showMessageDialog(this.getViewContainer(),
                                    "Can't create view",
                                    "Detail view creation error message",
                                    JOptionPane.ERROR_MESSAGE);
      return null;
    }
    return dv.getViewContainer();
  }

  private void jbInit() throws Exception {
    globalPanel.setLayout(borderLayout2);
    jPanelTop.setBorder(BorderFactory.createLoweredBevelBorder());
    jPanelTop.setMinimumSize(new Dimension(0, 0));
    jPanelTop.setLayout(flowLayout1);
    //jLabelDescription.setText("Type Ctrl-UP or Ctrl-DOWN to change tabbed pane    ");
    jLabelDescription.setMinimumSize(new Dimension(0, 0));
    jLabelDescription.setIconTextGap(0);
    jLabelDescription.setText("   ");
    flowLayout1.setAlignment(FlowLayout.CENTER);
    flowLayout1.setVgap(0);
    centerPanel.setLayout(borderLayout3);
    globalPanel.setMinimumSize(new Dimension(0, 0));
    centerPanel.setMinimumSize(new Dimension(0, 0));
    jTabbedPaneDACView.setMaximumSize(new Dimension(900, 900));
    jTabbedPaneDACView.setMinimumSize(new Dimension(0, 0));
    jTabbedPaneDACView.setPreferredSize(new Dimension(5, 5));
    globalPanel.add(jPanelTop, BorderLayout.NORTH);
    Timer timer = new Timer(200, new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String oldText = jLabelDescription.getText();
        String newText = oldText.substring(1) + oldText.substring(0, 1);
        jLabelDescription.setText(newText);
      }
    }
    );
    timer.start();
    jPanelTop.add(jLabelDescription, null);
    centerPanel.add(jTabbedPaneDACView, BorderLayout.CENTER);
    globalPanel.add(centerPanel, BorderLayout.CENTER);
  }
}
