package fr.unice.javinspector.MVC.view;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import fr.unice.javinspector.core.analyser.*;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import javax.swing.border.*;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Iterator;
import fr.unice.javinspector.GUI.util.*;
import fr.unice.javinspector.MVC.manager.Manager;
import fr.unice.javinspector.MVC.*;
import fr.unice.javinspector.GUI.util.CustomButton;

/**
 * <p>Title: GraphDetailsView </p>
 * <p>Description: this class builds a detail view</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class GraphDetailView extends DetailView {
  /**
   * The classifier analyser of the view
   */
  private ClassifierAnalyser classifierAnalyser;
  private FieldAnalyser[] field;
  private ConstructorAnalyser[] constructor;
  private MethodAnalyser[] method;
  private Class[] internalClasses;
  private ArrayList listenedJButtons = new ArrayList();
  // **** GUI OBJECTS ****
  private JPanel centerPanel = new JPanel();
  private JPopupMenu popup;
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private JPanel jPanelHead = new JPanel();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JCheckBox jCheckBoxFields = new JCheckBox();
  private JCheckBox jCheckBoxStaticFields = new JCheckBox();
  private JPanel jPanelFields = new JPanel();
  private JPanel jPanelStaticFields = new JPanel();
  private VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();
  private VerticalFlowLayout verticalFlowLayout3 = new VerticalFlowLayout();
  private JCheckBox jCheckBoxConstructors = new JCheckBox();
  private JPanel jPanelConstructors = new JPanel();
  private VerticalFlowLayout verticalFlowLayout4 = new VerticalFlowLayout();
  private Border border1;
  private TitledBorder titledBorder1;
  private TitledBorder titledBorder2;
  private Border border2;
  private TitledBorder titledBorder3;
  private JPanel jPanelMethods = new JPanel();
  private VerticalFlowLayout verticalFlowLayout5 = new VerticalFlowLayout();
  private Border border3;
  private TitledBorder titledBorder4;
  private JCheckBox jCheckBoxMethods = new JCheckBox();
  private JCheckBox jCheckBoxStaticMethods = new JCheckBox();
  private JPanel jPanelStaticMethods = new JPanel();
  private VerticalFlowLayout verticalFlowLayout6 = new VerticalFlowLayout();
  private Border border4;
  private TitledBorder titledBorder5;
  private Border border5;
  private TitledBorder titledBorder6;
  private JPanel jPanelSubHead = new JPanel();
  private FlowLayout flowLayout2 = new FlowLayout();
  private Border border6;
  private TitledBorder titledBorder7;
  private JCheckBox jCheckBoxAbstractMethod = new JCheckBox();
  private JPanel jPanelAbstractMethod = new JPanel();
  private VerticalFlowLayout verticalFlowLayout8 = new VerticalFlowLayout();
  private Border border7;
  private TitledBorder titledBorder8;
  private JScrollPane jScrollPane;
  private Manager dacViewManager;
  private JPanel jPanelClassifierName = new JPanel();
  private Border border8;
  private TitledBorder titledBorder9;
  private FlowLayout flowLayout3 = new FlowLayout();
  private JPanel jPanelGetterMethod = new JPanel();
  private JPanel jPanelSetterMethods = new JPanel();
  private VerticalFlowLayout verticalFlowLayout7 = new VerticalFlowLayout();
  private JPanel jPanelInternalClasses = new JPanel();
  private Border border9;
  private TitledBorder titledBorder10;
  private Border border10;
  private TitledBorder titledBorder11;
  private VerticalFlowLayout verticalFlowLayout9 = new VerticalFlowLayout();
  private VerticalFlowLayout verticalFlowLayout10 = new VerticalFlowLayout();
  private JCheckBox jCheckBoxGetterMethods = new JCheckBox();
  private JCheckBox jCheckBoxSetterMethods = new JCheckBox();
  private JCheckBox jCheckBoxRedefinedMethods = new JCheckBox();
  private JCheckBox jCheckBoxInternalClasses = new JCheckBox();
  private JPanel jPanelRedefinedMethods = new JPanel();
  private VerticalFlowLayout verticalFlowLayout11 = new VerticalFlowLayout();
  private Border border11;
  private TitledBorder titledBorder12;
  private  BorderLayout borderLayout1 = new BorderLayout();
  private FlowLayout flowLayout10 = new FlowLayout();

  /**
   * constructor of class by default
   */
 public GraphDetailView(){}

 /**
   * The constructor of the class
   * @param cl the ClassifierAnalyser associated to this class
   */
  public GraphDetailView(ClassifierAnalyser cl) {
    try {
      this.classifierAnalyser = cl;
      constructor = cl.getConstructor();
      field = cl.getField();
      method = cl.getMethod();
      jbInit();
      initializeJPanelName();
      initializeJPanelFields();
      initializeJPanelConstructors();
      initializeJPanelMethods();
      initializeJPanelInternalClasses();
      initialiseJPanelRedefinedMethod();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }

  /**
   * Needed by the Plugin interface
   * @return the name of this class
   */
  public String getName() {
    return this.getClass().getName();
  }

  /**
   * Needed by the View interface
   * @return : a container
   */
  public Container getViewContainer() {
    return centerPanel;
  }

  /**
   * this function initialise graphical elements
   */
  private void jbInit() throws Exception {
    border4 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(178, 178, 178));
    titledBorder5 = new TitledBorder(border4, "Static Method");
    border5 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(148, 145, 140));
    titledBorder6 = new TitledBorder(border5, "Static Methods");
    border6 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(148, 145, 140));
    titledBorder7 = new TitledBorder(border6, "Internal Classes");

    border7 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(148, 145, 140));
    titledBorder8 = new TitledBorder(border7, "Abstract Methods");
    border8 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(178, 178, 178));
    titledBorder9 = new TitledBorder(border8, "Classifier Name");
    border9 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(148, 145, 140));
    titledBorder10 = new TitledBorder(border9, "Getter Methods");
    border10 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                                new Color(178, 178, 178));
    titledBorder11 = new TitledBorder(border10, "Setter Methods");
    border11 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                                new Color(148, 145, 140));
    titledBorder12 = new TitledBorder(border11, "Redefined Methods");

    jCheckBoxStaticMethods.setBackground(new Color(103, 139, 199));

    jCheckBoxStaticMethods.setFocusPainted(false);
    jCheckBoxStaticMethods.setSelected(true);
    jCheckBoxStaticMethods.setText("Static Methods   ");
    jPanelStaticMethods.setLayout(verticalFlowLayout6);
    jPanelStaticMethods.setBackground(Color.white);
    jPanelStaticMethods.setBorder(titledBorder6);
    verticalFlowLayout6.setVgap(0);
    verticalFlowLayout1.setVgap(2);
    jPanelSubHead.setLayout(flowLayout2);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    flowLayout2.setVgap(5);
    jPanelSubHead.setBackground(Color.white);
    jCheckBoxFields.setActionCommand("CheckBox");
    jCheckBoxFields.setFocusPainted(false);
    jCheckBoxStaticFields.setActionCommand("CheckBox");
    jCheckBoxStaticFields.setFocusPainted(false);
    jCheckBoxConstructors.setActionCommand("CheckBox");
    jCheckBoxConstructors.setFocusPainted(false);
    jCheckBoxMethods.setActionCommand("CheckBox");
    jCheckBoxMethods.setFocusPainted(false);
    jCheckBoxAbstractMethod.setActionCommand("CheckBox");
    jCheckBoxAbstractMethod.setFocusPainted(false);
    jCheckBoxAbstractMethod.setSelected(true);
    jCheckBoxAbstractMethod.setText("Abstract Methods");
    jPanelAbstractMethod.setLayout(verticalFlowLayout8);
    jPanelAbstractMethod.setBackground(Color.white);
    jPanelAbstractMethod.setBorder(titledBorder8);
    verticalFlowLayout8.setVgap(0);
    jPanelClassifierName.setBackground(Color.white);
    jPanelClassifierName.setBorder(titledBorder9);
    jPanelClassifierName.setLayout(flowLayout3);
    flowLayout3.setAlignment(FlowLayout.LEFT);
    flowLayout3.setVgap(2);
    verticalFlowLayout7.setVgap(0);
    jPanelInternalClasses.setLayout(verticalFlowLayout7);
    jPanelInternalClasses.setBackground(Color.white);
    jPanelInternalClasses.setBorder(titledBorder7);
    jPanelGetterMethod.setBackground(Color.white);
    jPanelGetterMethod.setBorder(titledBorder10);
    jPanelGetterMethod.setLayout(verticalFlowLayout9);
    jPanelSetterMethods.setBackground(Color.white);
    jPanelSetterMethods.setBorder(titledBorder11);
    jPanelSetterMethods.setLayout(verticalFlowLayout10);
    verticalFlowLayout9.setVgap(0);
    verticalFlowLayout10.setVgap(0);
    jCheckBoxGetterMethods.setFocusPainted(false);
    jCheckBoxGetterMethods.setSelected(true);
    jCheckBoxGetterMethods.setText("Getter Methods");
    jCheckBoxGetterMethods.setActionCommand("CheckBox");
    jCheckBoxSetterMethods.setFocusPainted(false);
    jCheckBoxSetterMethods.setSelected(true);
    jCheckBoxSetterMethods.setText("Setter Methods");
    jCheckBoxSetterMethods.setActionCommand("CheckBox");
    jCheckBoxRedefinedMethods.setFocusPainted(false);
    jCheckBoxRedefinedMethods.setSelected(true);
    jCheckBoxRedefinedMethods.setText("Redefined Methods");
    jCheckBoxRedefinedMethods.setActionCommand("CheckBox");
    jCheckBoxInternalClasses.setBackground(Color.lightGray);
    jCheckBoxInternalClasses.setActionCommand("CheckBox");
    jCheckBoxInternalClasses.setFocusPainted(false);
    jCheckBoxInternalClasses.setSelected(true);
    jCheckBoxInternalClasses.setText("Internal Classes");
    jPanelRedefinedMethods.setLayout(verticalFlowLayout11);
    jPanelRedefinedMethods.setBackground(Color.white);
    jPanelRedefinedMethods.setBorder(titledBorder12);
    verticalFlowLayout11.setVgap(0);

    // here is the jbuilder show!!!
    border1 = BorderFactory.createEmptyBorder();
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,
        Color.white, new Color(178, 178, 178)), "Instance Fields");
    titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white,
        new Color(178, 178, 178)), "Static Fields");
    border2 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(178, 178, 178));
    titledBorder3 = new TitledBorder(border2, "Construcors");
    border3 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(148, 145, 140));
    titledBorder4 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,
        Color.white, new Color(148, 145, 140)), "Instance Methods");
    centerPanel.setLayout(verticalFlowLayout1);
    jPanelHead.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    jCheckBoxFields.setBackground(new Color(196, 0, 0));
    jCheckBoxFields.setSelected(true);
    jCheckBoxFields.setText("Instance Fields   ");

    jCheckBoxStaticFields.setBackground(new Color(79, 190, 138));
    jCheckBoxStaticFields.setSelected(true);
    jCheckBoxStaticFields.setText("Static Fields      ");

    jPanelFields.setLayout(verticalFlowLayout2);
    jPanelStaticFields.setLayout(verticalFlowLayout3);
    jPanelFields.setBackground(Color.white);
    jPanelFields.setBorder(titledBorder1);
    jPanelStaticFields.setBackground(Color.white);
    jPanelStaticFields.setBorder(titledBorder2);
    jCheckBoxConstructors.setBackground(Color.orange);
    jCheckBoxConstructors.setSelected(true);
    jCheckBoxConstructors.setText("Constructors   ");

    jPanelConstructors.setBackground(Color.white);
    jPanelConstructors.setBorder(titledBorder3);
    jPanelConstructors.setLayout(verticalFlowLayout4);
    centerPanel.setBackground(Color.white);
    jPanelHead.setBackground(Color.white);
    verticalFlowLayout2.setVgap(0);
    verticalFlowLayout3.setVgap(0);
    verticalFlowLayout4.setVgap(0);
    jPanelMethods.setLayout(verticalFlowLayout5);
    jPanelMethods.setBackground(Color.white);
    jPanelMethods.setBorder(titledBorder4);
    verticalFlowLayout5.setVgap(0);
    jCheckBoxMethods.setBackground(Color.magenta);
    jCheckBoxMethods.setSelected(true);
    jCheckBoxMethods.setText("Instance Methods    ");

    centerPanel.add(jPanelHead, null);
    jPanelHead.add(jCheckBoxFields, null);
    jPanelHead.add(jCheckBoxStaticFields, null);
    jPanelHead.add(jCheckBoxConstructors, null);
    jPanelHead.add(jCheckBoxMethods, null);
    jPanelHead.add(jCheckBoxStaticMethods, null);
    centerPanel.add(jPanelSubHead, null);
    jPanelSubHead.add(jCheckBoxAbstractMethod, null);
    jPanelSubHead.add(jCheckBoxGetterMethods, null);
    jPanelSubHead.add(jCheckBoxSetterMethods, null);
    jPanelSubHead.add(jCheckBoxRedefinedMethods, null);
    jPanelSubHead.add(jCheckBoxInternalClasses, null);
    centerPanel.add(jPanelClassifierName, null);
    centerPanel.add(jPanelFields, null);
    centerPanel.add(jPanelStaticFields, null);
    centerPanel.add(jPanelConstructors, null);
    centerPanel.add(jPanelMethods, null);
    centerPanel.add(jPanelStaticMethods, null);
    centerPanel.add(jPanelAbstractMethod, null);
    centerPanel.add(jPanelGetterMethod, null);
    centerPanel.add(jPanelSetterMethods, null);
    centerPanel.add(jPanelRedefinedMethods, null);
    centerPanel.add(jPanelInternalClasses, null);
    flowLayout10.setHgap(2);
    flowLayout10.setVgap(0);
  }

  /**
   * ========================================================================
   *           HERE WE DEAL WITH NAME OF CLASSIFIER
   * ========================================================================
   */

  /**
   * this function build the JPanel of class name
   */
  public void initializeJPanelName() {
    JLabel jLabel = new JLabel(classifierAnalyser.toString());
    jLabel.setFont(new Font("Courier", Font.PLAIN, 12));
    if(classifierAnalyser.getClassAnalysed().getPackage()!=null){
      jPanelClassifierName.setLayout(new VerticalFlowLayout());
      JLabel jLabel2 = new JLabel(classifierAnalyser.getClassAnalysed().getPackage().toString());
      jLabel2.setFont(new Font("Courier", Font.PLAIN, 12));
      jPanelClassifierName.add(jLabel2);
    }
    jPanelClassifierName.add(jLabel);
  }

  /**
   * ========================================================================
   *           HERE WE DEAL WITH FIELDS
   * ========================================================================
   */

  /**
   * this function build the panel of fields
   */
  public void initializeJPanelFields() {
    FlowLayout fl = new FlowLayout();
    fl.setAlignment(FlowLayout.LEFT);
    fl.setHgap(3);
    int nbStaticFields = 0;
    int nbInstanceFields = 0;
    for (int i = 0; i < field.length; i++) {
      JPanel jp = new JPanel();
      jp.setLayout(fl);
      jp.setBackground(Color.white);
      JLabel jLabelImage = new JLabel();
      jLabelImage.setIcon(IconBank.getFieldIcon(field[i].getModifier()));
      jp.add(jLabelImage);
      JTextArea jt = new JTextArea();
      jt.setEditable(false);
      jt.setFont(new Font("Courier", Font.BOLD, 12));
      jt.setForeground(Color.BLUE);
      jt.append(field[i].getStringModifier());
      jp.add(jt);

      if (field[i].getTypeClass().getCl().isPrimitive()) {
        JLabel jLabelType = myJLabel(field[i].getTypeName(), Color.BLACK);
        jp.add(jLabelType);
      }
      else {
        fr.unice.javinspector.GUI.util.CustomButton jb = new CustomButton(false, field[i].getTypeClass().getCl(),
                                           ClassifierAnalyser.shortName(field[i].getTypeName()),
                                           Color.CYAN, false);
        listenedJButtons.add(jb);
        jp.add(jb);
      }

      JLabel jLabelName = new JLabel();
      jLabelName.setFont(new Font("Courier", Font.PLAIN, 12));
      jLabelName.setForeground(Color.RED);
      if (field[i].isStatic()) {
        nbStaticFields++;
        jLabelName.setText(" " + field[i].getField().getName() + " = " +
                           field[i].getValue() + ";");
        jp.add(jLabelName);
        jPanelStaticFields.add(jp);
      }
      else {
        nbInstanceFields++;
        jLabelName.setText(" " + field[i].getField().getName() + ";");
        jp.add(jLabelName);
        jPanelFields.add(jp);
      }
    }
    if (nbInstanceFields == 0) {
      JLabel jLabelName = myJLabel("NO INSTANCE FIELDS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(),
                                   Color.BLACK);
      jPanelFields.add(jLabelName);
      jPanelFields.setVisible(false);
      jCheckBoxFields.setSelected(false);
    }
    if (nbStaticFields == 0) {
      JLabel jLabelName = myJLabel("NO STATIC FIELDS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(),
                                   Color.BLACK);
      jPanelStaticFields.add(jLabelName);
      jPanelStaticFields.setVisible(false);
      jCheckBoxStaticFields.setSelected(false);
    }

  }

  /**
   * this funtion returns a new label with the text "text" and the
   * Color color
   * @param text the text of the label
   * @param color of the label
   * @return a new label
   */
  public JLabel myJLabel(String text, Color color) {
    JLabel jLabelName = new JLabel();
    jLabelName.setFont(new Font("Courier", Font.PLAIN, 12));
    jLabelName.setForeground(color);
    jLabelName.setText(text);
    return jLabelName;
  }

  /**
   * =========================================================================
   *           HERE WE DEAL WITH CONSTRUCTORS
   * =========================================================================
   */

  /**
   * this function build the panel of constructors
   */
  public void initializeJPanelConstructors() {

    FlowLayout fl = new FlowLayout();
    fl.setAlignment(FlowLayout.LEFT);
    fl.setHgap(3);
    int i = 0;
    for (i = 0; i < constructor.length; i++) {
      JPanel jp = new JPanel();
      jp.setLayout(fl);
      jp.setBackground(Color.white);
      JLabel jLabelImage = new JLabel();
      jLabelImage.setIcon(IconBank.getConstructorIcon(constructor[i].getConstructor().getModifiers()));
      jp.add(jLabelImage);

      JLabel jLabelConstructorName = myJLabel(constructor[i].getStringModifier() +
                                              " "
                                              +
                                              constructor[i].getConstructor().
                                              getName(),
                                              Color.MAGENTA);
      jp.add(jLabelConstructorName);
      JLabel jLabelParenthes = myJLabel("(", Color.BLACK);
      jp.add(jLabelParenthes);

      TypeClass[] parameterType = constructor[i].getListTypeClass();
      initializeParameter(parameterType, jp);

      JLabel jLabelTmp = myJLabel(")", Color.BLACK);
      jp.add(jLabelTmp);

      initializeException(constructor[i].getConstructor().getExceptionTypes(),
                          jp);
      jPanelConstructors.add(jp);

    }
    if (i == 0) {
      JLabel jLabelName = myJLabel("NO CONSTRUCTORS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(),
                                   Color.BLACK);
      jPanelConstructors.add(jLabelName);
      jPanelConstructors.setVisible(false);
      jCheckBoxConstructors.setSelected(false);
    }

  }

  /**
   * ==========================================================================
   *                   HERE WE DEAL WITH METHODS
   * ==========================================================================
   */
  /**
   * this function build a panel for each method
   * @param methodAnalyser the instance of MethodAnalyser associated to
   * the method
   * @param fl the FlowLayout of the panel
   * @param img the image of the panel
   * @return a new JPanel
   */
  public JPanel jPanelEachMethod(MethodAnalyser methodAnalyser, FlowLayout fl,
                                 Icon img) {

    JPanel jp = new JPanel();
    jp.setLayout(fl);
    jp.setBackground(Color.white);
    JLabel jLabelImage = new JLabel();
    jLabelImage.setIcon(img);
    jp.add(jLabelImage);

    JLabel modif = new JLabel();
    modif.setFont(new Font("Courier", Font.BOLD, 12));
    modif.setForeground(Color.BLUE);

    modif.setText(methodAnalyser.getStringModifier());
    jp.add(modif);

    // HERE WE DEAL WITH RETURN TYPE
    TypeClass classReturn = methodAnalyser.getReturnType();
    if (classReturn.getCl().isPrimitive()) {
      JLabel returnType = new JLabel();
      returnType.setFont(new Font("Courier", Font.PLAIN, 12));
      returnType.setText(classReturn.getName() + " ");
      jp.add(returnType);
    }
    else {
      CustomButton jb = new CustomButton(false, classReturn.getCl(),
                                         ClassifierAnalyser.shortName(
          classReturn.getName()) + " ", Color.YELLOW, false);
      listenedJButtons.add(jb);
      jp.add(jb);
    }

    JLabel jLabelMethodName = myJLabel(methodAnalyser.getMethod().getName(),
                                       Color.BLACK);

    jp.add(jLabelMethodName);
    JLabel jLabelParenthes = myJLabel("(", Color.BLACK);
    jp.add(jLabelParenthes);

    TypeClass[] parameterType = methodAnalyser.getListTypeClass();
    initializeParameter(parameterType, jp);
    JLabel jLabelTmp = myJLabel(")", Color.BLACK);
    jp.add(jLabelTmp);
    return jp;
  }

  /**
   * this function build the JPanel Methods
   */
  public void initializeJPanelMethods() {

    FlowLayout fl = new FlowLayout();
    fl.setAlignment(FlowLayout.LEFT);
    fl.setHgap(3);
    String result = "";
    int methodAbs = 0;
    int methodStat = 0;
    int methodInst = 0;
    int getter = 0;
    int setter = 0;
    Font font = new Font("Courier", Font.BOLD, 12);
    ArrayList tmpList = classifierAnalyser.getHeritageClasses();
    for (int i = 0; i < method.length; i++) {
      JPanel jp = jPanelEachMethod(method[i], fl, IconBank.getMethodIcon(method[i].getModifier()));
      initializeException(method[i].getMethod().getExceptionTypes(), jp);
      if (method[i].isStatic()) {
        methodStat++;
        jPanelStaticMethods.add(jp);
      }
      else if (method[i].isAbstract()) {
        jPanelAbstractMethod.add(jp);
        methodAbs++;
      }
      else if (method[i].isGetter()) {
        jPanelGetterMethod.add(jp);
        getter++;
      }
      else if (method[i].isSetter()) {
        jPanelSetterMethods.add(jp);
        setter++;
      }
      else {
        jPanelMethods.add(jp);
        methodInst++;
      }
    }
    if (methodAbs == 0) {
      JLabel jLabelName = myJLabel("NO ABSTRACT METHODS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(), Color.BLACK);
      jPanelAbstractMethod.add(jLabelName);
      jPanelAbstractMethod.setVisible(false);
      jCheckBoxAbstractMethod.setSelected(false);

    }
    if (methodInst == 0) {
      JLabel jLabelName = myJLabel("NO INSTANCE METHODS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(),
                                   Color.BLACK);
      jPanelMethods.add(jLabelName);
      jPanelMethods.setVisible(false);
      jCheckBoxMethods.setSelected(false);
    }
    if (methodStat == 0) {
      JLabel jLabelName = myJLabel("NO STATIC METHODS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(),
                                   Color.BLACK);
      jPanelStaticMethods.add(jLabelName);
      jPanelStaticMethods.setVisible(false);
      jCheckBoxStaticMethods.setSelected(false);
    }
    if (getter == 0) {
      JLabel jLabelName = myJLabel("NO GETTER METHODS IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(),
                                   Color.BLACK);
      jPanelGetterMethod.add(jLabelName);
      jPanelGetterMethod.setVisible(false);
      jCheckBoxGetterMethods.setSelected(false);
    }
    if (setter == 0) {
          JLabel jLabelName = myJLabel("NO SETTER METHODS IN CLASSIFIER " +
                                       classifierAnalyser.getClassAnalysed().
                                       getName(),
                                       Color.BLACK);
          jPanelSetterMethods.add(jLabelName);
          jPanelSetterMethods.setVisible(false);
          jCheckBoxSetterMethods.setSelected(false);
   }

 }

  /**
   * ==========================================================================
   * HERE WE DEAL WITH INTERNAL CLASSES
   * ==========================================================================
   */

  public void initializeJPanelInternalClasses() {
    internalClasses = classifierAnalyser.getInternalClasses();
    FlowLayout fl = new FlowLayout();
    fl.setAlignment(FlowLayout.LEFT);
    fl.setHgap(3);
    ArrayList result = new ArrayList();
    String resultString = "";
    int i = 0;
    for (i = 0; i < internalClasses.length; i++) {
      JPanel jp = jPanelWithTextArea(ClassifierAnalyser.modifierToString(internalClasses[i]) + " ",
                                     IconBank.getClassifierIcon(internalClasses[i].getModifiers()),
                                     Color.BLUE);
      CustomButton jb = new CustomButton(false, internalClasses[i],
                                         ClassifierAnalyser.nameInternalClass(
          internalClasses[i]),
                                         Color.CYAN, false);
      listenedJButtons.add(jb);
      jp.add(jb);
      jPanelInternalClasses.add(jp);
    }
    int j = 0;
    ArrayList tmp = classifierAnalyser.getAnonymousInternalClasses();
    for (j = 0; j < tmp.size(); j++) {
      JPanel jp = jPanelWithTextArea(ClassifierAnalyser.modifierToString(
          (Class) tmp.get(j)) + " ", IconBank.getClassifierIcon(((Class)tmp.get(j)).getModifiers()),
                                     Color.BLUE);
      CustomButton jb = new CustomButton(false, (Class) tmp.get(j),
                                         ( (Class) tmp.get(j)).getName(),
                                         Color.CYAN, false);
      listenedJButtons.add(jb);
      jp.add(jb);
      jPanelInternalClasses.add(jp);
    }
    if (i == 0 && j == 0) {
      JLabel jLabelName = myJLabel("NO INTERNAL CLASSES IN CLASSIFIER " +
                                   classifierAnalyser.getClassAnalysed().
                                   getName(), Color.BLACK);
      jPanelInternalClasses.add(jLabelName);
      jPanelInternalClasses.setVisible(false);
      jCheckBoxInternalClasses.setSelected(false);
    }
  }

  /**
   * ==========================================================================
   *                        HERE WE DEAL WITH REDEFINED METHOD
   * ==========================================================================
   */

  /**
   * this function build the panel of redefined methods
   */
  public void initialiseJPanelRedefinedMethod() {
   Font font = new Font("Courier", Font.BOLD, 12);
   int comp = 0;
   MethodAnalyser ma;
   for (int i = 1; i < classifierAnalyser.getHeritageClasses().size(); i++) {
     Class tmpClass = (Class) classifierAnalyser.getHeritageClasses().get(i);
     JPanel jp = new JPanel();
     VerticalFlowLayout vfl = new VerticalFlowLayout();
     jp.setLayout(vfl);
     Border border = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                                      new Color(148, 145, 140));
     TitledBorder titledBorder = new TitledBorder(border,
         "Methods redefined from " + tmpClass.getName());
     jp.setBorder(titledBorder);
     jp.setBackground(Color.WHITE);
     ArrayList method = classifierAnalyser.getMethodRedefinedInClass(tmpClass);
     int k = 0;
     for (k = 0; k < method.size(); k++) {
       FlowLayout fl = new FlowLayout(FlowLayout.LEFT);
       ma = new MethodAnalyser((Method) method.get(k),classifierAnalyser);
       JPanel jp2 = jPanelEachMethod( ma, fl,
                                      IconBank.getMethodIcon(ma.getModifier()));
       jp.add(jp2);
     }
     if (k != 0){
       jPanelRedefinedMethods.add(jp);
       comp++;
     }
   }
   if (comp == 0){
     JLabel jLabelName = myJLabel("NO REDEFINED METHODS IN CLASSIFIER " +
                                  classifierAnalyser.getClassAnalysed().
                                  getName(),
                                  Color.BLACK);
     jPanelRedefinedMethods.add(jLabelName);
     jPanelRedefinedMethods.setVisible(false);
     jCheckBoxRedefinedMethods.setSelected(false);
   }
 }

  /**
   * ==========================================================================
   *                        HERE ARE THE UTILS FUNCTIONS
   * ==========================================================================
   */

  /**
   * this function is used for initialize all the exceptions
   * @param text
   * @param img
   * @param color
   */
  public JPanel jPanelWithTextArea(String text, Icon img, Color color) {
    FlowLayout fl = new FlowLayout();
    fl.setAlignment(FlowLayout.LEFT);
    fl.setHgap(3);

    JPanel jp = new JPanel();
    jp.setLayout(fl);
    jp.setBackground(Color.white);
    JLabel jLabelImage = new JLabel();
    jLabelImage.setIcon(img);
    jp.add(jLabelImage);
    JTextArea jt = new JTextArea();
    jt.setEditable(false);
    jt.setFont(new Font("Courier", Font.BOLD, 12));
    jt.setForeground(color);
    jt.append(text);
    jp.add(jt);
    return jp;
  }
  /**
   * this function initialise the exceptions of constructors and methods
   * @param cl the object of java.lang.Class who represents the type of the exceptions
   * @param jp a new panel
   */
  public void initializeException(Class[] cl, JPanel jp) {

    if (cl.length > 0) {
      int j;
      JLabel tmp = new JLabel();
      tmp.setFont(new Font("Courier", Font.PLAIN, 12));
      tmp.setForeground(Color.BLUE);
      tmp.setText("throws ");
      jp.add(tmp);
      for (j = 0; j < cl.length - 1; j++) {
        CustomButton jb = new CustomButton(false, cl[j],
                                           ClassifierAnalyser.shortName(cl[j].
            getName()) + " ,",
                                           Color.YELLOW, false);
        listenedJButtons.add(jb);
        jp.add(jb);
      }
      CustomButton jb = new CustomButton(false, cl[j],
                                         ClassifierAnalyser.
                                         shortName(cl[j].getName()),
                                         Color.YELLOW, false);
      listenedJButtons.add(jb);
      jp.add(jb);
    }
  }

  public void initializeParameter(TypeClass[] parameterType, JPanel jp) {
    if (parameterType.length > 0) {
      int j;
      for (j = 0; j < parameterType.length - 1; j++) {
        if (parameterType[j].getCl().isPrimitive()) {
          JLabel jLabelTmp = myJLabel(parameterType[j].getName() + ", ",
                                      Color.BLACK);
          jp.add(jLabelTmp);
        }
        else {
          CustomButton jb = new CustomButton(false, parameterType[j].getCl(),
                                             ClassifierAnalyser.shortName(
              parameterType[j].getName()) + " ,",
                                             Color.YELLOW, false);
          listenedJButtons.add(jb);
          jp.add(jb);
        }
      }
      if (parameterType[j].getCl().isPrimitive()) {
        JLabel jLabelTmp = myJLabel(parameterType[j].getName(), Color.BLACK);
        jp.add(jLabelTmp);
      }
      else {
        CustomButton jb = new CustomButton(false, parameterType[j].getCl(),
                                           ClassifierAnalyser.shortName(
            parameterType[j].getName()), Color.YELLOW, false);
        listenedJButtons.add(jb);
        jp.add(jb);
      }
    }
  }

  public JPopupMenu getPopup() {
    return popup;
  }

  public JCheckBox getJCheckBoxConstructors() {
    return jCheckBoxConstructors;
  }

  public JCheckBox getJCheckBoxFields() {
    return jCheckBoxFields;
  }

  public JCheckBox getJCheckBoxMethods() {
    return jCheckBoxMethods;
  }

  public JCheckBox getJCheckBoxStaticFields() {
    return jCheckBoxStaticFields;
  }

  public JPanel getJPanelConstructors() {
    return jPanelConstructors;
  }

  public JPanel getJPanelFields() {
    return jPanelFields;
  }

  public JPanel getJPanelHead() {
    return jPanelHead;
  }

  public JPanel getJPanelMethods() {
    return jPanelMethods;
  }

  public JPanel getJPanelStaticFields() {
    return jPanelStaticFields;
  }

  public JCheckBox getJCheckBoxInternalClasses() {
    return jCheckBoxInternalClasses;
  }

  public JCheckBox getJCheckBoxStaticMethods() {
    return jCheckBoxStaticMethods;
  }

  public JPanel getJPanelInternalClasses() {
    return jPanelInternalClasses;
  }

  public JPanel getJPanelStaticMethods() {
    return jPanelStaticMethods;
  }

  public JPanel getJPanelSubHead() {
    return jPanelSubHead;
  }

  public ClassifierAnalyser getClassifierAnalyser() {
    return classifierAnalyser;
  }

  public JCheckBox getJCheckBoxAbstractMethod() {
    return jCheckBoxAbstractMethod;
  }

  public JPanel getJPanelAbstractMethod() {
    return jPanelAbstractMethod;
  }
  public JCheckBox getJCheckBoxSetterMethods() {
    return jCheckBoxSetterMethods;
  }
  public JCheckBox getJCheckBoxGetterMethods() {
    return jCheckBoxGetterMethods;
  }
  public JCheckBox getJCheckBoxRedefinedMethods() {
    return jCheckBoxRedefinedMethods;
  }
  public JPanel getJPanelGetterMethod() {
    return jPanelGetterMethod;
  }
  public JPanel getJPanelSetterMethods() {
    return jPanelSetterMethods;
  }
  public JPanel getJPanelRedefinedMethods() {
    return jPanelRedefinedMethods;
  }
  public ArrayList getListenedJButtons() {
    return listenedJButtons;
  }
  public JPanel getCenterPanel() {
    return centerPanel;
  }
  public FieldAnalyser[] getField() {
    return field;
  }
  public void setField(FieldAnalyser[] field) {
    this.field = field;
  }
  public void setJPanelFields(JPanel jPanelFields) {
    this.jPanelFields = jPanelFields;
  }
  public void setJPanelStaticFields(JPanel jPanelStaticFields) {
    this.jPanelStaticFields = jPanelStaticFields;
  }


}
