package fr.unice.javinspector.MVC.view;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.util.ArrayList;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import java.util.Iterator;
import fr.unice.javinspector.GUI.util.CustomButton;
import fr.unice.javinspector.GUI.util.*;
import fr.unice.javinspector.MVC.controler.MyCompositionControler;

/**
 *
 * <p>Title: MyCompositionView</p>
 * <p>Description: this Class represents the composition graph of a classifier. It's a composition view,
 * so this class extends CompositionView.</p>
 * <p>Company: UNSA</p>
 * @author Lucas Charbit - Jerome Gahide - Galbois Xavier - Gabriel Zerbib
 * @version 1.0
 */
public class MyCompositionView extends CompositionView {
  /**
   * The classifierAnalyser of the view
   */
  private ClassifierAnalyser classifierAnalyser;
  /**
   * The JButton that a controler must listen to
   */
  private ArrayList listenedJButton = new ArrayList();
  private boolean isConstructorParameter = false;
  private boolean isConstructorException = false;
  private boolean isTypeField = false;
  // ***** GUI OBJECTS *****
  private JPanel globalPanel = new JPanel();
  private Border border1;
  private TitledBorder titledBorder1;
  private JPanel jPanelGlobal = new JPanel();
  private Border border2;
  private TitledBorder titledBorder2;
  private Border border3;
  private TitledBorder titledBorder3;
  private Border border4;
  private TitledBorder titledBorder4;
  private JPanel jPanelConstructor = new JPanel();
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private Border border5;
  private TitledBorder titledBorder5;
  private Border border6;
  private TitledBorder titledBorder6;
  private JPanel jPanelConstructorParameter = new JPanel();
  private VerticalFlowLayout verticalFlowLayout3 = new VerticalFlowLayout();
  private Border border7;
  private TitledBorder titledBorder7;
  private JPanel jPanelConstructorException = new JPanel();
  private VerticalFlowLayout verticalFlowLayout5 = new VerticalFlowLayout();
  private JPanel jPanelMethods = new JPanel();
  private VerticalFlowLayout verticalFlowLayout6 = new VerticalFlowLayout();
  private Border border8;
  private TitledBorder titledBorder8;
  private JPanel jPanelFieldAndLabel = new JPanel();
  private VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();
  private VerticalFlowLayout verticalFlowLayout4 = new VerticalFlowLayout();
  private VerticalFlowLayout verticalFlowLayout7 = new VerticalFlowLayout();
  private JPanel jPanelTypeField = new JPanel();
  private JPanel jPanelField = new JPanel();
  //private JPanel jPanelLabel = new JPanel();
  private JLabel jLabel2 = new JLabel();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JPanel jPanelMethodReturn = new JPanel();
  private JPanel jPanelMethodParameter = new JPanel();
  private JPanel jPanelMethodException = new JPanel();
  private VerticalFlowLayout verticalFlowLayout9 = new VerticalFlowLayout();
  private VerticalFlowLayout verticalFlowLayout10 = new VerticalFlowLayout();
  private VerticalFlowLayout verticalFlowLayout11 = new VerticalFlowLayout();
  private MyCompositionControler controler;
  private Border border9;
  private TitledBorder titledBorder9;
  private Border border10;
  private TitledBorder titledBorder10;
 // private JLabel jLabelConsParam = new JLabel();
  private BorderLayout borderLayout1 = new BorderLayout();

  //image
  private ImageIcon flecheBas =
      new ImageIcon(MyCompositionView.class.getResource("/imgs/arrowsdown.gif"));
  private ImageIcon flecheHaut =
      new ImageIcon(MyCompositionView.class.getResource("/imgs/arrowsup.gif"));
  // button
  private JButton jButtonConstructorParameter = myJButton();
  private JButton jButtonConstructorException = myJButton();
  private JButton jButtonField = myJButton();
  private JButton jButtonMethodsReturType = myJButton();
  private JButton jButtonMethodsParameter = myJButton();
  private JButton jButtonMethodException = myJButton();

  // panel
  private MyJPanel MyJPanelConstructorParam = new MyJPanel("  Parameters",
      jButtonConstructorParameter);
  private MyJPanel MyJPanelConstructorException = new MyJPanel("  Exceptions",
      jButtonConstructorException);
  private MyJPanel MyJPanelFieldType = new MyJPanel("  Type Field",
      jButtonField);
  private MyJPanel MyPanelMethodReturn = new MyJPanel("  Return Type",
      jButtonMethodsReturType);
  private MyJPanel MyJPanelMethodParameter = new MyJPanel("  Parameter",
      jButtonMethodsParameter);
  private MyJPanel MyJPanelMethodException = new MyJPanel("  Exception",
      jButtonMethodException);
  private JScrollPane jScrollPane;
  private JPanel globalPanel2 = new JPanel();

  /**
   * empty constructor
   */
  public MyCompositionView(){}

  /**
   * constructor with a ClassifierAnalyser
   * @param cl the ClassifierAnalyser of this view
   */
  public MyCompositionView(ClassifierAnalyser cl) {
    try {
      this.classifierAnalyser = cl;
      jbInit();
      initialiseTypeField();
      initialiseConstructorParameter();
      initialiseConstructorException();
      initialiseMethodParameter();
      initialiseMethodReturn();
      initialiseMethodException();
      changeSize();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

  }
  /**
   * return the name of this class
   * @return the name of this class
   */
  public String getName() {
    return this.getClass().getName();
  }
  /**
   * return the container of this view
   * @return the container of this view
   */
  public Container getViewContainer() {
    return globalPanel;
  }

  // ***** DON'T EDIT *****
  /**
   * the initialisation of the graphics elements of this view
   * @throws Exception
   */
  void jbInit() throws Exception {
    border5 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(148, 145, 140));
    titledBorder5 = new TitledBorder(BorderFactory.createEmptyBorder(),
                                     "  ");
    border7 = BorderFactory.createEmptyBorder();
    titledBorder7 = new TitledBorder(border7, "   ");
    border8 = BorderFactory.createEmptyBorder();
    titledBorder8 = new TitledBorder(border8, "  ");

    globalPanel.setLayout(flowLayout1);
    BoxLayout box = new BoxLayout(jPanelGlobal, BoxLayout.X_AXIS);
    jPanelGlobal.setLayout(box);

    jPanelConstructor.setLayout(verticalFlowLayout1);
    jPanelConstructor.setBackground(Color.white);
    jPanelConstructor.setBorder(titledBorder5);
    jPanelConstructorParameter.setLayout(verticalFlowLayout3);
    globalPanel.setBackground(Color.white);
    jPanelConstructorException.setLayout(verticalFlowLayout5);
    jPanelGlobal.setBackground(Color.white);
    jPanelConstructorParameter.setBackground(Color.white);
    jPanelConstructorParameter.setBorder(null);
    jPanelConstructorException.setBackground(Color.white);
    jPanelMethods.setLayout(verticalFlowLayout6);
    jPanelMethods.setBackground(Color.white);
    jPanelMethods.setBorder(titledBorder8);
    jPanelFieldAndLabel.setLayout(verticalFlowLayout2);
    jPanelTypeField.setBackground(Color.white);
    jPanelTypeField.setLayout(verticalFlowLayout4);
    jPanelField.setBorder(titledBorder7);
    jPanelField.setBackground(Color.white);
    jPanelField.setLayout(verticalFlowLayout7);
    jLabel2.setText("Composition Graph");
    jPanelFieldAndLabel.setBackground(Color.white);

    verticalFlowLayout3.setVgap(0);
    verticalFlowLayout4.setVgap(0);
    verticalFlowLayout4.setVerticalFill(true);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    jPanelMethodReturn.setLayout(verticalFlowLayout9);
    jPanelMethodParameter.setLayout(verticalFlowLayout10);
    jPanelMethodException.setLayout(verticalFlowLayout11);
    verticalFlowLayout1.setVgap(2);
    verticalFlowLayout7.setVgap(2);
    verticalFlowLayout9.setVgap(0);
    verticalFlowLayout10.setVgap(0);
    verticalFlowLayout11.setVgap(0);
    jPanelMethodReturn.setBackground(Color.white);
    jPanelMethodParameter.setBackground(Color.white);
    jPanelMethodException.setBackground(Color.white);
    verticalFlowLayout5.setVgap(0);
    verticalFlowLayout6.setVgap(2);
    verticalFlowLayout2.setVgap(5);
    globalPanel.add(jPanelGlobal, null);
    jPanelGlobal.add(jPanelConstructor, null);
    JLabel tmpLabel = new JLabel("CONSTRUCTORS");
    tmpLabel.setFont(new Font(tmpLabel.getFont().getFamily(), Font.BOLD, 12));
    tmpLabel.setForeground(Color.RED);
    jPanelConstructor.add(tmpLabel);
    JPanel tmpPanel = new JPanel();
    tmpPanel.setPreferredSize(new Dimension(10, 13));
    tmpPanel.setBackground(Color.WHITE);
    jPanelConstructor.add(tmpPanel);
    jPanelConstructor.add(MyJPanelConstructorParam, null);
    jPanelConstructor.add(jPanelConstructorParameter, null);
    jPanelConstructor.add(MyJPanelConstructorException, null);
    jPanelConstructor.add(jPanelConstructorException, null);
    jPanelGlobal.add(jPanelFieldAndLabel, null);
    FlowLayout labelLayout = new FlowLayout(FlowLayout.LEFT);
    labelLayout.setHgap(0);
    labelLayout.setVgap(0);
    jPanelFieldAndLabel.add(jLabel2, null);
    jPanelFieldAndLabel.setBackground(Color.white);
    jPanelFieldAndLabel.add(jPanelField, null);

    // initialisation of panel fields
    tmpLabel = new JLabel("FIELDS");
    tmpLabel.setFont(new Font(tmpLabel.getFont().getFamily(), Font.BOLD, 12));
    tmpLabel.setForeground(Color.RED);
    jPanelField.add(tmpLabel);
    tmpPanel = new JPanel();
    tmpPanel.setPreferredSize(new Dimension(10, 13));
    tmpPanel.setBackground(Color.WHITE);
    jPanelField.add(tmpPanel);
    jPanelField.add(MyJPanelFieldType, null);
    jPanelField.add(jPanelTypeField, null);

    // initialisation of panel methods
    tmpLabel = new JLabel("METHODS");
    tmpLabel.setFont(new Font(tmpLabel.getFont().getFamily(), Font.BOLD, 12));
    tmpLabel.setForeground(Color.RED);
    jPanelMethods.add(tmpLabel);
    tmpPanel = new JPanel();
    tmpPanel.setPreferredSize(new Dimension(10, 13));
    tmpPanel.setBackground(Color.WHITE);
    jPanelMethods.add(tmpPanel);
    jPanelMethods.add(MyPanelMethodReturn, null);
    jPanelMethods.add(jPanelMethodReturn, null);
    jPanelMethods.add(MyJPanelMethodParameter, null);
    jPanelMethods.add(jPanelMethodParameter, null);
    jPanelMethods.add(MyJPanelMethodException, null);
    jPanelMethods.add(jPanelMethodException, null);

    jPanelGlobal.add(jPanelMethods, null);
  }
  /**
   * this function initialise the panel of the parameter type constructors
   */
  public void initialiseConstructorParameter() {
    ArrayList l = classifierAnalyser.getConstructorsParameterType();
    for (Iterator i = l.iterator(); i.hasNext(); ) {
      Class item = (Class) i.next();
      CustomButton jb = new CustomButton(false, item, "  " +
                                         ClassifierAnalyser.shortName(item.
          getName()), Color.CYAN, true);
      if(item.isPrimitive()){
        jb.setBackground(new Color(138,138,255));
      }
      jb.setHorizontalAlignment(SwingConstants.LEFT);
      jb.setPreferredSize(new Dimension(95, 27));
      listenedJButton.add(jb);
      jPanelConstructorParameter.add(jb);
    }
    if(l.size() == 0){
      JLabel label = new JLabel("NO PARAMETERS");
      jPanelConstructorParameter.add(label);
    }
  }
  /**
   * this function initialise the panel of the exception type of constructors
   */
  public void initialiseConstructorException() {
    ArrayList l = classifierAnalyser.getConstructorsException();
    for (Iterator i = l.iterator(); i.hasNext(); ) {
      Class item = (Class) i.next();
      CustomButton jb = new CustomButton(false, item, "  " +
                                         ClassifierAnalyser.shortName(item.
          getName()), Color.CYAN, true);
      if(item.isPrimitive()){
       jb.setBackground(new Color(138,138,255));
     }

      jb.setHorizontalAlignment(SwingConstants.LEFT);
      jb.setPreferredSize(new Dimension(95, 27));
      listenedJButton.add(jb);
      jPanelConstructorException.add(jb);
    }
    if(l.size() == 0){
     JLabel label = new JLabel("NO EXCEPTIONS");
     jPanelConstructorException.add(label);
   }

  }
  /**
   * this function initiliase the type of fields
   */
  public void initialiseTypeField() {
    ArrayList l = classifierAnalyser.getTypeField();
    for (Iterator i = l.iterator(); i.hasNext(); ) {
      Class item = (Class) i.next();
      CustomButton jb = new CustomButton(false, item, "  " +
                                         ClassifierAnalyser.shortName(item.
          getName()), Color.YELLOW, true);
      if(item.isPrimitive()){
             jb.setBackground(new Color(138,138,255));
           }

      jb.setHorizontalAlignment(SwingConstants.LEFT);
      jb.setPreferredSize(new Dimension(95, 27));
      listenedJButton.add(jb);
      jPanelTypeField.add(jb);
    }
    if(l.size() == 0){
      JLabel label = new JLabel("NO FIELDS");
      jPanelTypeField.add(label);
    }
  }

  /**
   * this function initialise the panel of the parameters of the methods
   */
  public void initialiseMethodParameter() {
    ArrayList l = classifierAnalyser.getMethodsParameterType();

    for (Iterator i = l.iterator(); i.hasNext(); ) {
      Class item = (Class) i.next();
      CustomButton jb = new CustomButton(false, item, "  " +
                                         ClassifierAnalyser.shortName(item.
          getName()), Color.ORANGE, true);
      if(item.isPrimitive()){
             jb.setBackground(new Color(138,138,255));
           }

      jb.setHorizontalAlignment(SwingConstants.LEFT);
      jb.setPreferredSize(new Dimension(95, 27));
      listenedJButton.add(jb);
      jPanelMethodParameter.add(jb);
    }
    if(l.size() == 0){
      JLabel label = new JLabel("NO PARAMETERS");
      jPanelMethodParameter.add(label);
    }
  }
  /**
   * this function initialise the panel of the return type of the methodds
   */
  public void initialiseMethodReturn() {
    ArrayList l = classifierAnalyser.getMethodReturnType();

    for (Iterator i = l.iterator(); i.hasNext(); ) {
      Class item = (Class) i.next();
      CustomButton jb = new CustomButton(false, item, "  " +
                                         ClassifierAnalyser.shortName(item.
          getName()), Color.ORANGE, true);
      if(item.isPrimitive()){
             jb.setBackground(new Color(138,138,255));
           }

      jb.setHorizontalAlignment(SwingConstants.LEFT);
      jb.setPreferredSize(new Dimension(95, 27));
      listenedJButton.add(jb);
      jPanelMethodReturn.add(jb);
    }
    if(l.size() == 0){
      JLabel label = new JLabel("NO RETURN TYPE");
      jPanelMethodReturn.add(label);
    }
  }
  /**
   * this function initialise the panel of the exceptions of the methods
   */
  public void initialiseMethodException() {
    ArrayList l = classifierAnalyser.getMethodsExceptions();
    for (Iterator i = l.iterator(); i.hasNext(); ) {
      Class item = (Class) i.next();
      CustomButton jb = new CustomButton(false, item, "  " +
                                         ClassifierAnalyser.shortName(item.
          getName()), Color.ORANGE, true);
      if(item.isPrimitive()){
             jb.setBackground(new Color(138,138,255));
           }

      jb.setHorizontalAlignment(SwingConstants.LEFT);
      jb.setPreferredSize(new Dimension(95, 27));
      listenedJButton.add(jb);
      jPanelMethodException.add(jb);
    }
    if(l.size() == 0){
     JLabel label = new JLabel("NO EXCEPTIONS");
     jPanelMethodException.add(label);
   }
  }

  // a small internal class
  class MyJPanel extends JPanel {
    private String name;
    private JButton button;
    /**
     * the constructor
     * @param name the name of the label of the panel
     * @param button the jbutton of the panel
     */
    MyJPanel(String name, JButton button) {
      this.button = button;
      this.name = name;
      this.setLayout(new BorderLayout());
      JLabel label = new JLabel(this.name);
      label.setFont(new Font(label.getFont().getFamily(), Font.BOLD, 12));
      this.add(label, BorderLayout.CENTER);
      JPanel jpBibon = new JPanel(new FlowLayout(FlowLayout.CENTER));
      jpBibon.add(this.button);
      this.add(jpBibon, BorderLayout.EAST);

      this.setBorder(BorderFactory.createLineBorder(Color.black));
      this.setPreferredSize(new Dimension(158, 28));
    }
  }
  /**
   * this function change the size of the global panel
   */
  public void changeSize() {
    int tailleField = jPanelFieldAndLabel.getPreferredSize().height;
    int tailleMethod = jPanelMethods.getPreferredSize().height;
    int tailleCons = jPanelConstructor.getPreferredSize().height;

    int taille = 10;
    if (tailleField >= tailleCons && tailleField >= tailleMethod) {
      taille += tailleField;
    }
    else if (tailleMethod >= tailleCons && tailleMethod >= tailleField) {
      taille += tailleMethod;
    }
    else if (tailleCons >= tailleMethod && tailleCons >= tailleField) {
      taille += tailleCons;
    }
    globalPanel.setPreferredSize(new Dimension(580, taille));
  }
  /**
   * this function returns a custom button
   * @return a new JButton
   */
  public JButton myJButton() {
    JButton jb = new JButton();
    jb.setActionCommand("MyJButton");
    jb.setPreferredSize(new Dimension(17, 17));
    jb.setBorderPainted(false);
    jb.setFocusPainted(false);
    jb.setHorizontalAlignment(SwingConstants.CENTER);
    jb.setIcon(flecheHaut);
    jb.setToolTipText("close this panel");
    listenedJButton.add(jb);
    jb.setActionCommand("MyJButton");
    return jb;
  }

// here are all the getter and the setter
  public JPanel getJPanelConstructorException() {
    return jPanelConstructorException;
  }

  public JPanel getJPanelConstructorParameter() {
    return jPanelConstructorParameter;
  }

  public JPanel getJPanelField() {
    return jPanelField;
  }

  public JPanel getJPanelMethodException() {
    return jPanelMethodException;
  }

  public JPanel getJPanelMethodParameter() {
    return jPanelMethodParameter;
  }

  public JPanel getJPanelMethodReturn() {
    return jPanelMethodReturn;
  }

  public JPanel getJPanelConstructor() {
    return jPanelConstructor;
  }

  public JPanel getJPanelFieldAndLabel() {
    return jPanelFieldAndLabel;
  }

  public JPanel getJPanelMethods() {
    return jPanelMethods;
  }

  public JPanel getJPanelTypeField() {
    return jPanelTypeField;
  }

  public ImageIcon getFlecheBas() {
    return flecheBas;
  }

  public ImageIcon getFlecheHaut() {
    return flecheHaut;
  }
  public ArrayList getListenedJButton() {
    return listenedJButton;
  }
  public JButton getJButtonConstructorException() {
    return jButtonConstructorException;
  }
  public JButton getJButtonConstructorParameter() {
    return jButtonConstructorParameter;
  }
  public JButton getJButtonField() {
    return jButtonField;
  }
  public JButton getJButtonMethodException() {
    return jButtonMethodException;
  }
  public JButton getJButtonMethodsParameter() {
    return jButtonMethodsParameter;
  }
  public JButton getJButtonMethodsReturType() {
    return jButtonMethodsReturType;
  }
  public JPanel getGlobalPanel() {
    return globalPanel;
  }
}
