package fr.unice.javinspector.MVC.view;

import java.awt.Container;
import fr.unice.javinspector.plugin.Plugin;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
/**
 * <p>Title: Interface View</p>
 * <p>Description: This interface needs to be implemented by each view</p>
 * <p>Company: UNSA</p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public interface View extends Plugin{

  /**
   * This function returns the container where all the graphics elements of the view has been
   * draw
   * @return : a container
   */
  public Container getViewContainer();

  /**
   * Return the classifierAnalyser related to this view
   * @return : a classifierAnalyser
   */
  public ClassifierAnalyser getClassifierAnalyser();

  /**
   * Set the current classifierAnalyser for this view
   * @param ca : the new classifierAnalyser
   */
  public void setClassifierAnalyser(ClassifierAnalyser ca);
}
