package fr.unice.javinspector;

import java.awt.*;
import fr.unice.javinspector.GUI.*;
import fr.unice.javinspector.GUI.main.*;
import javax.swing.*;
import fr.unice.javinspector.GUI.util.*;

/**
 * <p>Title: Class MainClass</p>
 * <p>Description: The main of the application. This class create the JavInspectorGui.</p>
 * <p>Company: UNSA</p>
 * @author Charbit Lucas - Gahide Jrome - Galbois Xavier - Zerbib Gabriel
 * @version 1.0
 */

public class MainClass {
  boolean packFrame = false;

    public final static String fSep = System.getProperty("file.separator"); // file separator

  /**
   * The constructor
   */
  public MainClass() {
    JavInspectorGUI frame = new JavInspectorGUI();
    new LogoFrame(frame, 2000);
    frame.setSize(800, 600);
    frame.setIconImage(new ImageIcon(MainClass.class.getResource("/imgs/littlelogoji.gif")).getImage());//fSep+"imgs"+fSep+"littlelogoji.gif")).getImage());
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  //Main method
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    // make the start window appear
    new LogoFrame(null, 3000);
    // load the icon bank
    
    IconBank.load();
    new MainClass();
    new TipsFrame("resources/tips.xml").show();
  }
}
