package fr.unice.javinspector.core.XML;

import javax.swing.filechooser.FileFilter;
import java.io.File;


/**
 *
 * <p>Title: XMLFilter </p>
 * <p>Description: just a little XML filter for the JFileChooser</p>
 * <p>Company: UNSA</p>
 * @author Lucas Charbit - Jerome Gahide - Galbois Xavier - Gabriel Zerbib
 * @version 1.0
 */
public class XMLFilter extends FileFilter {

  /**
   * return true if the file f is accepted by the Filter
   * @param f the File to test
   * @return true if the file f is accepted by the Filter
   */
  public boolean accept(File f) {
    return f.isDirectory()
        || f.getName().endsWith("xml")
        || f.getName().endsWith("XML");
  }

  /**
   * get the description of Filter
   * @return a String that represents the name of Filter
   */
  public String getDescription() {
    return "Just XML file (*.xml)";
  }
}
