package fr.unice.javinspector.core.engineSearch;

import java.util.ArrayList;
import java.lang.reflect.Member;
import java.lang.reflect.Modifier;

import java.lang.reflect.Method;

/**
 * <p>Title: PrivateCriterion</p>
 * <p>Description: the criterion that test if the member is private</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class PrivateCriterion extends Criterion {


  /**
   * Construct a new instance of this criterion.
   * This overwrite the name of the criterion
   */
  public PrivateCriterion() {
    this.name = "private";
  }

  /**
   * test if the member matches to this criterion.
   * @param m the member that we want to check the validity.
   * @return true if the Criterion is Valid for this Member
   * @throws SearchEngineException
   */
 public boolean isCriterionValid(Member m) {

   if( isActive == EngineSearchConst.NOT){
     return !Modifier.isPrivate(m.getModifiers());
   }
   else if( isActive == EngineSearchConst.YES){
     return Modifier.isPrivate(m.getModifiers());
   }
   else if( isActive == EngineSearchConst.DONTMIND){
     // if i don't mind of the result, I always return true
     // logic !!
     return true;
   }
   else{
     System.err.println("Erreur de const engine search");
     return false;
   }

 }
}
