package fr.unice.javinspector.core.engineSearch;

import java.util.ArrayList;
import java.lang.reflect.Member;
import java.lang.reflect.Modifier;

/**
 * <p>Title: PublicCriterion</p>
 * <p>Description: the criterion that test if the member is public</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNSA</p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public class PublicCriterion extends Criterion {


  /**
   * Construct a new instance of this criterion.
   * This overwrite the name of the criterion
   */
  public PublicCriterion() {
    this.name = "public";
  }

  /**
   * test if the member matches to this criterion.
   * @param m the member that we want to check the validity.
   * @return true if the Criterion is Valid for this Member
   * @throws SearchEngineException
   */
  public boolean isCriterionValid(Member m)
      throws SearchEngineException{
    if( isActive == EngineSearchConst.NOT){
      return !Modifier.isPublic(m.getModifiers());
    }
    else if( isActive == EngineSearchConst.YES){
      return Modifier.isPublic(m.getModifiers());
    }
    else if( isActive == EngineSearchConst.DONTMIND){
      // if i don't mind of the result, I always return true
      // logic !!
      return true;
    }
    else{
     throw new SearchEngineException("isCriterionValid : Public Criterion : ");
    }
  }
}
