package fr.unice.javinspector.plugin;

import java.util.Hashtable;
import java.util.Map;

/**
 * <p>Title: Class Plugin settings</p>
 * <p>Description: Stores the settings of the plugins (which plugin shoud
 * be asciotated to a type of plugin) </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public class PluginSettings extends Hashtable {

  /**
   * Default constructor
   */
  public PluginSettings() {
  }

  /**
   * sets this class <code>c</code> for the type <code>type</code>
   * @param type the type
   * @param c the class (a Plugin)
   * @see fr.unice.javinspector.plugin.PluginTypes
   */
  public void put(int type, Class c){
    super.put(new Integer(type), c);
  }

  /**
   * sets this class <code>c</code> for the type <code>type</code>
   * @param type the type
   * @param c the class (a Plugin)
   * @see fr.unice.javinspector.plugin.PluginTypes
   */
  public void put(Integer type, Class c){
    super.put(type, c);
  }

  /**
   * gets the class for the type <code>type</code>
   * @param type  the type
   * @return the corresponding class
   */
  public Class get(int type){
    return (Class) super.get(new Integer(type));
  }

  /**
   * gets the class for the type <code>type</code>
   * @param type  the type
   * @return the corresponding class
   */
  public Class get(Integer type){
    return (Class) super.get(type);
  }
}
