package fr.unice.javinspector.util;

import java.util.Hashtable;
import java.awt.Color;

/**
 * <p>Title: DictionnaryWordStyle </p>
 * <p>Description: this class represent a dictionnary of words that are associated
 * with some Style. This class is usefull with the JTextPaneAutoStyled.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 * @see javax.swing.text.Style
 * @see fr.unice.javinspector.GUI.util.JTextPaneAutoStyled
 */

public class DictionnaryWordStyle {

  private Hashtable dictionnary;

  /**
   * Create a new empty dictionnary.
   */
  public DictionnaryWordStyle() {
    dictionnary = new Hashtable();
  }

  /**
   * Add an entrie to the dictionnary
   * @param word the word to be styled
   * @param styleName the name of the style
   */
  public void addEntrie(String word, String styleName){
    dictionnary.put(word, styleName);
  }

  /**
   *
   * @param aWord the word we want the associated style.
   * @return the name of the style if the word exist, else return null .
   */
  public String getStyleForThisWord(String aWord){
    String res = (String)dictionnary.get(aWord);
    return res;
  }

  /**
   * Set the word to the new Style.
   * If the word don't exist, the procedure do nothing.
   * @param aWord the word to change the style
   * @param c the new name of the style.
   */
  public void SetStyleForThisWord(String aWord, String c){
    if( dictionnary.containsKey(aWord) ){
      dictionnary.remove(aWord);
      dictionnary.put(aWord, c);
    }

  }

}
